unit u_test;

{$I gspdemo.inc }

interface

uses
  Windows,  SysUtils, Classes,
  ComCtrls, Controls, StdCtrls, ExtCtrls,
  ShellApi,
  Forms,Messages,
  Graphics,
  Dialogs,
  contnrs,
  lzbasetype,
  gsqlparser,
  sqlstatement,
  selectstatement,
  insertstatement,
  updatestatement,
  deletestatement,
  mergestatement,
  lzExpression,
  u_nodes,
  u_parsenodes,
  lzbasevisitor,
  gettextvisitor,
  lzdbobjects,
  langconverter,
  xmldom, XMLIntf, msxmldom, XMLDoc;


type
  Tfrmdemo = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ts2: TTabSheet;
    mmsqlfile: TRichEdit;
    reinputsqlstrings: TRichEdit;
    sqlinput: TRichEdit;
    sqloutput: TRichEdit;
    Label9: TLabel;
    rg_caseoption: TRadioGroup;
    rg_lf_comma: TRadioGroup;
    rg_lf_andor: TRadioGroup;
    btnpp: TButton;
    cbdbvendor: TComboBox;
    rg_keywordalign: TRadioGroup;
    rg_listoption: TRadioGroup;
    tsxml: TTabSheet;
    TreeView1: TTreeView;
    Memo1: TMemo;
    Button11: TButton;
    memo2: TRichEdit;
    TabSheet2: TTabSheet;
    mminput: TMemo;
    mmoutput: TMemo;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    StatusBar1: TStatusBar;
    TabSheet3: TTabSheet;
    mmsqls: TMemo;
    tvsqlobjects: TTreeView;
    btninspect: TButton;
    mmerrors: TMemo;
    btnTolang: TButton;
    GroupBox2: TGroupBox;
    rbReadfromfile: TRadioButton;
    rbreadfromstrings: TRadioButton;
    GroupBox3: TGroupBox;
    rbSavetostrings: TRadioButton;
    rbSavetofile: TRadioButton;
    edinputsqlfile: TEdit;
    btninputfile: TButton;
    edoutputsqlfile: TEdit;
    GroupBox4: TGroupBox;
    rbchecksyntax: TRadioButton;
    rbprettyprint: TRadioButton;
    rbgetclause: TRadioButton;
    BtnParse: TButton;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    TabSheet4: TTabSheet;
    mm1: TMemo;
    tv1: TTreeView;
    tv2: TTreeView;
    Button5: TButton;
    TabSheet5: TTabSheet;
    Memo3: TMemo;
    Memo4: TMemo;
    btnfindvariable: TButton;
    TabSheet6: TTabSheet;
    Memo6: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    GroupBox5: TGroupBox;
    cbOnTokenlizerToken: TCheckBox;
    cbOnGetRawSqlStatement: TCheckBox;
    GroupBox6: TGroupBox;
    cbOnParserToken: TCheckBox;
    cbOnParserTokenError: TCheckBox;
    Label3: TLabel;
    GroupBox7: TGroupBox;
    cbonstatementtable: TCheckBox;
    cbonstatementfield: TCheckBox;
    btngo1: TButton;
    Button7: TButton;
    btngo2: TButton;
    Memo5: TMemo;
    btnInspectbyEvent: TButton;
    mminspectedobjs: TMemo;
    tsvisitor: TTabSheet;
    Memo7: TMemo;
    Memo8: TMemo;
    Button1: TButton;
    tsbuildsql: TTabSheet;
    mmbuildsql: TMemo;
    btnbuildsql: TButton;
    btnexprgetdbobj: TButton;
    tsModifyExpr: TTabSheet;
    Memo9: TMemo;
    Memo10: TMemo;
    TreeView2: TTreeView;
    btnflattenexpr: TButton;
    Label4: TLabel;
    ednewexprvalue: TEdit;
    btnsetnewvalue: TButton;
    Label5: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    btnFetchDBObject: TButton;
    btntablehint: TButton;
    cmblanguages: TComboBox;
    rgidentcase: TRadioGroup;
    cbselectiteminnewline: TCheckBox;
    cbfromclauseinnewline: TCheckBox;
    cbalignaliasinselectlist: TCheckBox;
    Label8: TLabel;
    Label12: TLabel;
    btnexprvisit: TButton;
    rgexprvisit: TRadioGroup;
    Memo11: TMemo;
    tsjoinconvertor: TTabSheet;
    Memo12: TMemo;
    Memo13: TMemo;
    btnoracle: TButton;
    btnmssqlserver: TButton;
    Memo14: TMemo;
    Label16: TLabel;
    Label17: TLabel;
    Memo15: TMemo;
    edvars: TEdit;
    Label18: TLabel;
    btnremovevarinwhere: TButton;
    Label19: TLabel;
    edfields: TEdit;
    btnremovefieldinwhereclause: TButton;
    btnisfieldinexpr: TButton;
    tsdbexplorer: TTabSheet;
    redbexplorer: TRichEdit;
    treeviewdbexplorer: TTreeView;
    btndbexplorer: TButton;
    mmdbexplorer: TMemo;
    btnonlinexmldemo: TButton;
    Label20: TLabel;
    Label21: TLabel;
    XMLDocument1: TXMLDocument;
    btnpp_rtf: TButton;
    lbelements: TListBox;
    cbelement: TColorBox;
    GroupBox1: TGroupBox;
    cbstylebold: TCheckBox;
    cbstyleitalic: TCheckBox;
    cbstyleunderline: TCheckBox;
    cbstylestrikeout: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnppClick(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure btninspectClick(Sender: TObject);
    procedure BtnParseClick(Sender: TObject);
    procedure rbreadfromstringsClick(Sender: TObject);
    procedure rbReadfromfileClick(Sender: TObject);
    procedure rbSavetofileClick(Sender: TObject);
    procedure rbSavetostringsClick(Sender: TObject);
    procedure btninputfileClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure btnfindvariableClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure btnTolangClick(Sender: TObject);
    procedure btngo1Click(Sender: TObject);
    procedure btngo2Click(Sender: TObject);
    procedure btnInspectbyEventClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnbuildsqlClick(Sender: TObject);
    procedure btnexprgetdbobjClick(Sender: TObject);
    procedure btnflattenexprClick(Sender: TObject);
    procedure TreeView2Click(Sender: TObject);
    procedure btnsetnewvalueClick(Sender: TObject);
    procedure btnFetchDBObjectClick(Sender: TObject);
    procedure btntablehintClick(Sender: TObject);
    procedure btnexprvisitClick(Sender: TObject);
    procedure btnoracleClick(Sender: TObject);
    procedure btnmssqlserverClick(Sender: TObject);
    procedure btnremovevarinwhereClick(Sender: TObject);
    procedure btnremovefieldinwhereclauseClick(Sender: TObject);
    procedure btnisfieldinexprClick(Sender: TObject);
    procedure btndbexplorerClick(Sender: TObject);
    procedure treeviewdbexplorerClick(Sender: TObject);
    procedure tsdbexplorerShow(Sender: TObject);
    procedure btnonlinexmldemoClick(Sender: TObject);
    procedure btnpp_rtfClick(Sender: TObject);
    procedure lbelementsClick(Sender: TObject);
    procedure cbelementChange(Sender: TObject);
    procedure cbstyleboldClick(Sender: TObject);
    procedure cbstyleitalicClick(Sender: TObject);
    procedure cbstyleunderlineClick(Sender: TObject);
    procedure cbstylestrikeoutClick(Sender: TObject);
  private
    { Private declarations }
      //fcConvert : TStringsConverter;
    function GetCurrentParser:TGsqlparser;
    procedure pp(isPlainText : boolean);
  public
    { Public declarations }
      asql : TCustomSqlStatement;
      msaccessparser,genericparser,oracleparser,mssqlparser,mysqlparser,db2parser : Tgsqlparser;
      procedure testprocess(aSubstitutionVarList: TSubstitutionVarList);
      procedure BindVarTestProcess(owner:TObject;const asqlstatement: TCustomSqlStatement; const bindvarname: lzstring; var replacestr: lzstring);
      procedure On_TokenlizerToken(sender : TObject; Const st: TSourceToken; var DeleteThisToken : Boolean);
      procedure On_TokenlizerTokenError(sender : TObject; Const st: TSourceToken);
      procedure On_GetRawSqlStatement(sender : TObject; Const asqlstatement: TCustomSqlStatement);

      function parsefile(afilename:lzstring):lzstring;
      procedure showsqlclause(psqlparser : TGsqlparser);
      function SelectStmtInfo(pSqlstmt : TSelectSqlStatement):lzstring;
      function InsertStmtInfo(pSqlstmt : TInsertSqlStatement):lzstring;
      function UpdateStmtInfo(pSqlstmt : TUpdateSqlStatement):lzstring;
      function DeleteStmtInfo(pSqlstmt : TDeleteSqlStatement):lzstring;
      function toplevelExpr(pexpr : TLzCustomExpression) : lzstring;
      procedure XML2TreeView(Filename: lzstring; XML: TXMLDocument; TV: TTreeview);
      procedure DbObjs2TreeView(dbobjs : TObjectlist; TV: TTreeview);

  /////////////Join Table
    procedure getjoin(pctv : TTreeView;pcnode:TTreeNode;pcJoin : TLzJoin);
    procedure getjoinitem(pctv : TTreeView;pcnode:TTreeNode;pcJoinItem : TLzJoinItem);
    procedure getjoinitems(pctv : TTreeView;pcnode:TTreeNode;pcJoinItems : TLzJoinItemList);

    procedure getjoinObq(pctv : TTreeView;pcnode:TTreeNode;pcJoin : TLzJoin);
    procedure getjoinitemobq(pctv : TTreeView;pcnode:TTreeNode;pcJoinItem : TLzJoinItem);

    procedure addallsubjoinitems(pctv : TTreeView;pcnode:TTreeNode;pcJoinItems : TLzJoinItemList;pmParentId:integer);
    procedure  getjointable(pctv : TTreeView;pcJoins : TLzJoinList);
    procedure  getjointableOrderbyQual(pctv : TTreeView;pcJoins : TLzJoinList);

  ////////////bind and substitution variable
      procedure simplexprocess(aSubstitutionVarList: TSubstitutionVarList);
      procedure BindVarTestProcess1(owner:TObject;const bindvarname: lzstring; var replacestr: lzstring);
      procedure VarTestProcess1(owner:TObject;const varname: lzstring; var replacestr: lzstring);

  /////////////event handle
      procedure On_TokenlizerToken1(sender : TObject; Const st: TSourceToken);
      procedure On_TokenlizerTokenError1(sender : TObject; Const st: TSourceToken);
      procedure On_GetRawSqlStatement1(sender : TObject; Const sqltype: TSqlStatementType; Const StartPos,EndPos : integer);


      procedure On_ParserToken(sender : TObject; var pToken : TSourceToken ;const pDbVendor : integer);
      procedure On_ParserTokenError(sender : TObject;var pToken : TSourceToken ;const pDbVendor : integer; const  pExpectedTokens : lzstring; var pAction :TActionOnParseError; var pRollbackTokens : integer;var pRollbackState: Boolean);

//      procedure On_StatementField(sender : TObject; Const asqlstatement: TCustomSqlStatement;pField : TLzField);
//      procedure On_StatementTable(sender : TObject; Const asqlstatement: TCustomSqlStatement;pTable : TLzTable);

      procedure MyOnTableToken(Sender : Tobject; pToken : TSourceToken;psqlstatement: TCustomSqlStatement);
      procedure MyOnFieldToken(Sender : Tobject; pToken : TSourceToken;psqlstatement: TCustomSqlStatement);

      procedure MyOnTableToken_replacetable(Sender : Tobject; pToken : TSourceToken;psqlstatement: TCustomSqlStatement);

      function exprvisit(const pnode : tlz_node; pIsLeafNode : Boolean):boolean;
      procedure DBObject2TreeView(pServerList : TLzDBObjectList ; TV: TTreeview);

  end;


  TLzRemoveTokenVisitor = Class(TLzVisitorAbs)
  private
     FInfoStack : TObjectlist;
     Fvars : TLzStringlist;
  protected
    function AcceptVisitor : boolean ; overload ; override ;
    function DoConvert:integer;
  public
    ParseTree : TLz_node;
    expr1 : TLzCustomExpression;
    strs : lzString;
    attr : TLz_attr;
    constructor Create ; override;
    Destructor Destroy;override;
    function   Convert:integer;
    procedure  Execute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure  PreExecute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure  PostExecute( const pVisited : TLzVisitedAbs ) ; override ;
  end;

  TLzCheckFieldVisitor = Class(TLzVisitorAbs)
  private
     FInfoStack : TObjectlist;
     Fvars : TLzStringlist;
      attr : TLz_attr;
  protected
    function AcceptVisitor : boolean ; overload ; override ;
  public
    ParseTree : TLz_node;
    strs : lzString;
    IsFieldIn : Boolean;
    constructor Create ; override;
    Destructor Destroy;override;
    function   Convert:Boolean;
    procedure  Execute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure  PreExecute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure  PostExecute( const pVisited : TLzVisitedAbs ) ; override ;
  end;

  TLzParseTree2XMLVisitor = Class(TLzVisitorAbs)
  protected
  public
    ParseTree : TLz_node;
    XmlStr : lzstring;
    constructor Create ; override;
    function Visit:integer;
    procedure   Execute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure   PreExecute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure   PostExecute( const pVisited : TLzVisitedAbs ) ; override ;
  end;

  TLzParseTreeVisitor = Class(TLzVisitorAbs)
  protected
  public
    ParseTree : TLz_node;
    constructor Create ; override;
    function Visit:integer;
    procedure   Execute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure   PreExecute( const pVisited : TLzVisitedAbs ) ; override ;
    procedure   PostExecute( const pVisited : TLzVisitedAbs ) ; override ;
  end;

  const linebreak = #13#10;
  
var

  retries,kwcount,identcount,stringcount,numbercount,singlecharcount,multicharcount : integer;
  bindvarcount,WhiteSpacecount,returncount,commentcount,unknowncharcount : integer;
  frmdemo: Tfrmdemo;

  mytablelist,myfieldlist : TStringlist;
  

  procedure Expr2TreeView(pcExpr : TLzCustomExpression;TV: TTreeview);

implementation

uses buildsql;

{$R *.DFM}

procedure Tfrmdemo.FormCreate(Sender: TObject);
begin
   genericparser := Tgsqlparser.Create;

  {$ifdef DBV_ORACLE}
   try
     oracleparser := Tgsqlparser.Create(DbvOracle);
   except
     on e:exception do
       showmessage(e.message);
   end;
  {$endif}

  {$ifdef DBV_MSSQL}
   try
     mssqlparser :=  Tgsqlparser.Create(DbvMssql);
   except
     on e:exception do
       showmessage(e.message);
   end;
  {$endif}

  {$ifdef DBV_MYSQL}
   try
     mysqlparser := Tgsqlparser.Create(DbvMysql);
   except
     on e:exception do
       showmessage(e.message);
   end;
  {$endif}

  {$ifdef DBV_MSACCESS}
   try
     msaccessparser := Tgsqlparser.Create(Dbvaccess);
   except
     on e:exception do
       showmessage(e.message);
   end;
  {$endif}

  {$ifdef DBV_DB2}
   try
     db2parser := Tgsqlparser.Create(Dbvdb2);
   except
     on e:exception do
       showmessage(e.message);
   end;
  {$endif}

  lbelements.Clear;
  lbelements.AddItem('comment',gfmtopt.highlightingelements[sfkComment_dh]);
  lbelements.AddItem('Keyword',gfmtopt.highlightingelements[sfkStandardkeyword]);
  lbelements.AddItem('Identifier',gfmtopt.highlightingelements[sfkIdentifer]);
  lbelements.AddItem('Symbol',gfmtopt.highlightingelements[sfkSymbol]);
  lbelements.AddItem('String',gfmtopt.highlightingelements[sfkSQString]);
  lbelements.AddItem('Number',gfmtopt.highlightingelements[sfkNumber]);
  lbelements.AddItem('Function',gfmtopt.highlightingelements[sfkFunction]);
  lbelements.AddItem('Datatype',gfmtopt.highlightingelements[sfkDatatype]);
  lbelements.AddItem('Variable',gfmtopt.highlightingelements[sfksqlvar]);

  lbelements.ItemIndex := 0;
  lbelementsClick(nil);
end;

procedure Tfrmdemo.FormDestroy(Sender: TObject);
begin
   if assigned(genericparser) then
     genericparser.free;
   if assigned(oracleparser) then
     oracleparser.free;
   if assigned(mssqlparser) then
     mssqlparser.Free;
   if assigned(mysqlparser) then
     mysqlparser.free;
   if assigned(msaccessparser) then
     msaccessparser.Free;
   if assigned(db2parser) then
     db2parser.Free;
end;

procedure Tfrmdemo.testprocess(aSubstitutionVarList: TSubstitutionVarList);
var
  i:Integer;
begin
  for i:=0 to aSubstitutionVarList.Count -1 do
    begin
      aSubstitutionVarList[i].VarValue := InputBox('Input Box', 'Input value for '+aSubstitutionVarList[i].VarName+', param:'+aSubstitutionVarList[i].VarParam, '');
    end;
end;



function Tfrmdemo.parsefile(afilename: lzstring): lzstring;
var
  agsqlparser : TGsqlparser;
  ret:Integer;
begin
  agsqlparser := GetCurrentParser;

//  mmsqlfile.Lines.clear;
//  mmessages.lines.clear;

  agsqlparser.Sqlfilename := afilename;
  agsqlparser.OnSubstitutionVar := testprocess;
  agsqlparser.IsProcessSubstitutionVar := false;
  ret := agsqlparser.checksyntax;
  if ret = 0 then result := 'parse '+afilename+' ok'
  else
    result := 'parse '+afilename+' error: '+#13#10+agsqlparser.errormessages;
end;

procedure Tfrmdemo.BindVarTestProcess(owner: TObject;
  const asqlstatement: TCustomSqlStatement; const bindvarname: lzstring;
  var replacestr: lzstring);
begin
  replacestr := InputBox('Input Box for bind variable', 'Input value for bind variable: '+bindvarname, '');
end;

procedure Tfrmdemo.On_TokenlizerToken(sender: TObject;
  const st: TSourceToken; var DeleteThisToken: Boolean);
begin

  case st.TokenType of
    ttKeyword: begin inc(kwcount); end;
    ttIdentifier,ttDQString : inc(identcount);
    ttNumber : inc(numbercount);
    ttSQString : inc(stringcount);
    ttWhitespace : inc(whitespacecount);
    ttReturn : inc(returncount);
    ttDoublehyphenComment,ttSlashStarComment : inc(commentcount);
    ttDBString: begin
      st.SourceCode := '"'+copy(st.SourceCode,2,length(st.SourceCode)-2)+'"';
    end;
    else
      begin
        if st.TokenType in ttsSingleChar then inc(singlecharcount)
        else if st.TokenType in ttsMultiChar then inc(multicharcount)
        else  inc(unknowncharcount);
      end;
  end;
end;

procedure Tfrmdemo.On_TokenlizerTokenError(sender: TObject;
  const st: TSourceToken);
begin
  showmessage('On Tokenlizer token error:'+st.SourceCode);
end;

procedure Tfrmdemo.On_GetRawSqlStatement(sender: TObject;
  const asqlstatement: TCustomSqlStatement);
begin
  showmessage('sql raw:'+asqlstatement.RawSqlText);
  //this property  available only after parse, so what showed here is not corrected
  showmessage('sqldesc: '+asqlstatement.SqlDesc);
end;

function Tfrmdemo.SelectStmtInfo(pSqlstmt: TSelectSqlStatement): lzstring;
var
  lcStr : lzstring;
  i:integer;
begin

      case pSqlstmt.SelectSetType of
        sltNone: lcStr := 'Select set type: none';
        sltUnion:
          begin
            lcStr := #13#10+'Select set type: union';
            lcStr := lcStr+#13#10+'left statement: '+SelectStmtInfo(pSqlstmt.leftstmt)+#13#10+'right statement: '+#13#10+SelectStmtInfo(pSqlstmt.rightstmt);
          end;
        sltUnionAll:
          begin
            lcStr := #13#10+'Select set type: union all';
          lcStr := lcStr+#13#10+'left statement: '+SelectStmtInfo(pSqlstmt.leftstmt)+#13#10+'right statement: '+#13#10+SelectStmtInfo(pSqlstmt.rightstmt);
          end;
        sltMinus:
          begin
            lcStr := #13#10+'Select set type: minus';
          lcStr := lcStr+#13#10+'left statement: '+SelectStmtInfo(pSqlstmt.leftstmt)+#13#10+'right statement: '+#13#10+SelectStmtInfo(pSqlstmt.rightstmt);
          end;
        sltIntersect:
          begin
            lcStr := #13#10+'Select set type: insertsect';
          lcStr := lcStr+#13#10+'left statement: '+SelectStmtInfo(pSqlstmt.leftstmt)+#13#10+'right statement: '+#13#10+SelectStmtInfo(pSqlstmt.rightstmt);
          end;
      end;

  if pSqlstmt.selectsettype <> sltNone then
    begin
     lcStr := lcStr+#13#10+'order by  clause:'+pSqlStmt.sortclausetext;
     lcStr := lcStr+#13#10+'for upate  clause:'+pSqlStmt.forupdateclausetext;
     result := lcStr;
      exit;
    end;

  if pSqlstmt.Params.Count > 0 then
    begin
      lcStr := 'Parameters(bind variable):';
      for i:=0 to pSqlstmt.Params.Count - 1 do
        lcStr := lcStr+#13#10+'Name: '+pSqlstmt.Params[i].ValueName+ ' Value:'+pSqlstmt.Params[i].ValueStr
    end;

  lcStr := lcStr+#13#10+'Select distinct:'+pSqlStmt.SelectDistinctText;
  lcStr := lcStr+#13#10+'select clause:';
  lcStr := lcStr+#13#10+pSqlStmt.selectclausetext;

  for i:=0 to pSqlStmt.fields.Count - 1 do
    begin
      lcStr := lcStr+#13#10+'fieldtable:'+pSqlStmt.fields.Fields[i].fieldPrefix;
      lcStr := lcStr+#13#10+'fieldname:'+pSqlStmt.fields.Fields[i].fieldname;
      lcStr := lcStr+#13#10+'fieldalias:'+pSqlStmt.fields.Fields[i].fieldalias;
    end;

  lcStr := lcStr+#13#10+'from clause:';
  lcStr := lcStr+#13#10+pSqlStmt.fromclausetext;
  for i:=0 to pSqlStmt.tables.Count - 1 do
    begin
      lcStr := lcStr+#13#10+'tableowner:'+pSqlStmt.tables.tables[i].tablePrefix;
      lcStr := lcStr+#13#10+'tablename:'+pSqlStmt.tables.tables[i].tablename;
      lcStr := lcStr+#13#10+'tablealias:'+pSqlStmt.tables.tables[i].tablealias;
    end;

  lcStr := lcStr+#13#10+'where clause:'+pSqlStmt.whereclausetext;
  lcStr := lcStr+#13#10+'groupby clause:'+pSqlStmt.groupbyclausetext;
  lcStr := lcStr+#13#10+'having clause:'+pSqlStmt.havingclausetext;
  lcStr := lcStr+#13#10+'order by  clause:'+pSqlStmt.sortclausetext;
  lcStr := lcStr+#13#10+'for upate  clause:'+pSqlStmt.forupdateclausetext;


  lcStr := lcStr+#13#10+'top clause:'+pSqlStmt.topclausetext;
  lcStr := lcStr+#13#10+'limit clause:'+pSqlStmt.limitclausetext;

  result := lcStr;

end;

function Tfrmdemo.DeleteStmtInfo(pSqlstmt: TDeleteSqlStatement): lzstring;
var
  lcStr : lzstring;
  i:integer;
begin

  if pSqlstmt.Params.Count > 0 then
    begin
      lcStr := 'Parameters(bind variable):';
      for i:=0 to pSqlstmt.Params.Count - 1 do
        lcStr := lcStr+#13#10+'Name: '+psqlstmt.Params[i].ValueName+ ' Value:'+pSqlstmt.Params[i].ValueStr
    end;

  lcStr := lcStr+#13#10+'table: '+pSqlStmt.tables[0].astext;//tabletext;
  lcStr := lcStr+#13#10+'where clause: '+pSqlStmt.whereclausetext;
  lcStr := lcStr+#13#10+'returning clause: '+pSqlStmt.ReturningClauseText;

  result := lcStr;
end;

function Tfrmdemo.InsertStmtInfo(pSqlstmt: TInsertSqlStatement): lzstring;
var
  lcStr : lzstring;
  i:integer;
begin

  if pSqlstmt.Params.Count > 0 then
    begin
      lcStr := 'Parameters(bind variable):';
      for i:=0 to pSqlstmt.Params.Count - 1 do
        lcStr := lcStr+#13#10+'Name: '+pSqlstmt.Params[i].ValueName+ ' Value:'+pSqlstmt.Params[i].ValueStr
    end;

  lcStr := lcStr+#13#10+'table: '+pSqlStmt.tabletext;
  lcStr := lcStr+#13#10+'columns: '+pSqlStmt.columnlisttext;
  lcStr := lcStr+#13#10+'values: '+pSqlStmt.valuelisttext;
  lcStr := lcStr+#13#10+'returning clause: '+pSqlStmt.ReturningClauseText;

  result := lcStr;
end;

function Tfrmdemo.UpdateStmtInfo(pSqlstmt: TUpdateSqlStatement): lzstring;
var
  lcStr : lzstring;
  i:integer;
begin

  if pSqlstmt.Params.Count > 0 then
    begin
      lcStr := 'Parameters(bind variable):';
      for i:=0 to pSqlstmt.Params.Count - 1 do
        lcStr := lcStr+#13#10+'Name: '+pSqlstmt.Params[i].ValueName+ ' Value:'+pSqlstmt.Params[i].ValueStr
    end;

  lcStr := lcStr+#13#10+'table: '+pSqlStmt.tabletext;
  lcStr := lcStr+#13#10+'set clause: '+pSqlStmt.SetClauseText;
  lcStr := lcStr+#13#10+'where clause: '+pSqlStmt.whereclausetext;
  lcStr := lcStr+#13#10+'returning clause: '+pSqlStmt.ReturningClauseText;

  result := lcStr;

end;

function Tfrmdemo.toplevelExpr(pexpr: TLzCustomExpression): lzstring;
begin
  result := '';
  if not assigned(pexpr) then exit;
  if (pExpr.oper = Expr_And) then
    result := toplevelExpr(TLzExpression(pexpr.lexpr))+#13#10+'and '+pexpr.rexpr.AsText
  else if (pExpr.oper = Expr_or) then
    result :=toplevelExpr(TLzExpression(pexpr.lexpr))+#13#10+'or '+result+pexpr.rexpr.AsText
  else
    result := pexpr.AsText;
end;


procedure Tfrmdemo.FormActivate(Sender: TObject);
var
  i:Integer;
begin
  for i:= integer(low(DbVendorStr)) to integer(high(DbVendorStr)) do
    begin
      case TDbVendor(i) of
        DBVOracle :
          begin
            {$ifdef DBV_ORACLE}
              cbdbvendor.Items.Add(DbVendorStr[TDbVendor(i)]);
            {$endif}
          end;
        DBVMSSql :
          begin
            {$ifdef DBV_MSSQL}
              cbdbvendor.Items.Add(DbVendorStr[TDbVendor(i)]);
            {$endif}
          end;
        DBVMySql :
          begin
            {$ifdef DBV_MYSQL}
              cbdbvendor.Items.Add(DbVendorStr[TDbVendor(i)]);
            {$endif}
          end;
        DBVaccess :
          begin
            {$ifdef DBV_MSACCESS}
              cbdbvendor.Items.Add(DbVendorStr[TDbVendor(i)]);
            {$endif}
          end;
        DBVDB2 :
          begin
            {$ifdef DBV_DB2}
              cbdbvendor.Items.Add(DbVendorStr[TDbVendor(i)]);
            {$endif}
          end;
      end;
    end;
  cbdbvendor.ItemIndex := 0;
  // rbSavetoStringsClick(nil);
  // rbreadfromstringsClick(nil);
   opendialog1.InitialDir := extractfilepath(application.exename)+'test';
end;

procedure Tfrmdemo.btnppClick(Sender: TObject);
begin
  pp(true);
end;

procedure Tfrmdemo.Button11Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
 // xmlvs: TLzParseTree2XMLVisitor;
  textvs : TLzGetTextVisitor;
  //xmldocument1: TXMLDocument;
begin

  agsqlparser := GetCurrentParser;

  memo2.Lines.clear;

  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(memo1.Lines);

  agsqlparser.OnSubstitutionVar := testprocess;
  agsqlparser.IsProcessSubstitutionVar := false;
  retries := 0;

  ret := agsqlparser.parse;


  if agsqlparser.ErrorCount > 0 then
    begin
     memo2.Lines.clear;
     memo2.Lines.add(agsqlparser.errormessages);
    end;

  if ret <> 0 then exit;
  memo2.Lines.add(agsqlparser.XmlText);
  treeview1.Items.Clear;
  xmldocument1.xml.Clear;
  xmldocument1.xml.Add(agsqlparser.XmlText);
  xmldocument1.Active := true;
  XML2TreeView('',xmldocument1,treeview1);


end;

procedure Tfrmdemo.XML2TreeView(Filename: lzstring; XML: TXMLDocument;
  TV: TTreeview);

procedure ReadXML(Root:TTreeNode; Node:IXMLNode);
var i:integer; newNode:TTreeNode;
str1,str2:lzstring;
begin
for i:=0 to Node.ChildNodes.Count-1 do
begin
 str1 :=  Node.ChildNodes.Nodes[i].NodeName;
 if str1 = '#text' then
   str2 := Node.ChildNodes.Nodes[i].xml;
newNode:=TV.Items.AddChild( Root,str1+ ':' +str2 );
//newNode:=TV.Items.AddChild(Root,Node.ChildNodes[i].NodeName + ':' + Node.ChildNodes[i].xml);
ReadXML(newNode, Node.ChildNodes.Nodes[i]);
end;
end;

begin
ReadXML(nil, XML.Node);
end;

procedure Tfrmdemo.Button16Click(Sender: TObject);
var
  lcgsqlparser : TGsqlparser;
  ret : integer;
  asqlstmt : TSelectSqlStatement;
  lcnode : TLz_node;
begin
  mmoutput.Clear;
  lcgsqlparser := TGsqlparser.create(tdbvendor(cbdbvendor.ItemIndex));
  lcgsqlparser.SqlText.assign(mminput.Lines);
  ret := lcgsqlparser.Parse;
  try
    if lcgsqlparser.SqlStatements.Count = 0 then exit;
    if lcgsqlparser.SqlStatements[0].SqlStatementType <> sstSelect then exit;
    asqlstmt := TSelectSqlStatement(lcgsqlparser.SqlStatements[0]);

    //add table owner
    asqlstmt.Tables.Tables[0].TablePrefix := 'scott';

    // add a condition to where clause
    if not assigned(asqlstmt.WhereClause) then exit; 
    asqlstmt.WhereClause.AsText := asqlstmt.WhereClauseText+' and 1=1';

    lcnode := TLzCustomExpression(asqlstmt.WhereClause).lexpr;
    if assigned(lcnode) then
      lcnode.AsText := ''''+TLzCustomExpression(lcnode).astext +'''';//+' and sss>d ';
    // delete order by clause
    asqlstmt.SortClauseText := ' ';
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);
    asqlstmt.SortClausetext := ''; //set to empty char (not a single space),make sortclausetext read
                                   //from sortclause object again

    asqlstmt.RawSqlText := asqlstmt.SqlDesc;

    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add('Sql rawtext ');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.rawsqltext);

    asqlstmt.Parse;
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after reparse');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

  finally
    lcgsqlparser.Free;
  end;
end;

procedure Tfrmdemo.Button17Click(Sender: TObject);
var
  VSqlStatement : TSelectSqlStatement;
  i:integer;
  VParserJoin : TLzJoinItem ;
  VParser : TGSQLParser;

begin
  VParser := getcurrentparser;
  try
    VParser.SqlText.Assign(mminput.Lines);
    i := VParser.ParseSqlStatements;
    if i <> 0 then
      showmessage(VParser.ErrorMessages)
    else
    begin
      if VParser.SqlStatements[0].SqlStatementType = sstSelect then
      begin
        VSqlStatement := TSelectSqlStatement(VParser.SqlStatements[0]);
        if VSqlStatement.JoinTables <> NIL  then
        begin
          VParserJoin := TLzJoinItem.Create(VSqlStatement);
          VParserJoin.AsText :=  ' inner join table3  ON t1.f3  = table3.f3';
          VSqlStatement.JoinTables[0].joinitems.Add( VParserJoin) ;

          mmoutput.Text := VSqlStatement.AsText;
        end;
      end;
   end;
  finally
    // VParser.Free;
  end;

end;

procedure Tfrmdemo.Button18Click(Sender: TObject);
var
  ret : integer;
  asqlstmt : TSelectSqlStatement;
  lcField : TLzField;
begin
  mminput.Clear;
  mminput.Lines.Text := 'select count(*), last_name,job_id'+#13#10+
                        ' from employee'+#13#10+
                        ' where manager_id is null'+#13#10+
                        ' group by job_id '+#13#10+
                        ' having count(*) > 2'+#13#10+
                        ' order by department_id,salary desc';
  mmoutput.Clear;
  asqlstmt := TSelectSqlStatement.Create(tdbvendor(cbdbvendor.ItemIndex));
  asqlstmt.RawSqlText := mminput.Lines.Text;
  ret := asqlstmt.Parse;
  try
    mmoutput.Lines.Add(asqlstmt.SqlDesc);
    //add table owner
    asqlstmt.Tables.Tables[0].TablePrefix := 'scott';
    //add a alias to field 0
    lcField := asqlstmt.fields[0];
    lcField.fieldalias := '"total count"';
    lcField.IsHasAs := true;
    //add field
    // more specific
    lcField := TLzField.create(nil);
    lcField.fieldname := 'mycol4';
    lcField.fieldalias := 'mycol4_alias';
    asqlstmt.Fields.Add(lcField);

    //more easy use astext
    lcField := TLzField.create(nil);
    lcField.AsText := 'mycol5 as mycol4_alias';
    asqlstmt.Fields.Add(lcField);

    // add a condition to where clause
    asqlstmt.WhereClauseText := ' (1=1) and '+'--Comment here'
    +#13#10+'/*'+'('+asqlstmt.WhereClauseText+')'+'*/'
    +' -- this is removed where clause'
    +#13#10+'(mycol4 = :mycol4 or mycol5 = :mycol5)';
    // delete order by clause
    asqlstmt.SortClauseText := ' ';

    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

    asqlstmt.SortClausetext := ''; //set to empty char (not a single space),make sortclausetext read
                                   //from sortclause object again


    asqlstmt.RawSqlText := asqlstmt.SqlDesc;
    ret := asqlstmt.Parse;
   // if ret <> 0 then
   //   mmoutput.Lines.Add(asqlstmt.ErrorMessages)
   // else
      begin
        mmoutput.Lines.Add('');
        mmoutput.Lines.Add('Sql text after reparse');
        mmoutput.Lines.Add('---------------------------');
        mmoutput.Lines.Add(asqlstmt.sqldesc);
      end;
  finally
    asqlstmt.Free;
  end;

end;

procedure Tfrmdemo.Button19Click(Sender: TObject);
var
  ret : integer;
  asqlstmt : TInsertSqlStatement;
begin
  mminput.Clear;
  mminput.Lines.Text := 'insert into emp(last_name,job_id)'+#13#10+
                        ' values(scott,10)';
  mmoutput.Clear;
  asqlstmt := TInsertSqlStatement.Create(tdbvendor(cbdbvendor.ItemIndex));
  asqlstmt.RawSqlText := mminput.Lines.Text;
  ret := asqlstmt.Parse;
  try
    mmoutput.Lines.Add(asqlstmt.SqlDesc);
    //add table owner
    asqlstmt.Tabletext := 'dept';
    asqlstmt.fields[0].AsText := 'f1';

    //value is a subquery
    asqlstmt.ValueType := ivtsubquery;
    asqlstmt.ValueListText := 'select dept_id,dept_name from dept_bak';

    //value is a expression
//    asqlstmt.ValueType := ivtValue;
//    asqlstmt.ValueListText := 'dept_id,dept_name';
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

    asqlstmt.RawSqlText := asqlstmt.SqlDesc;
    ret := asqlstmt.Parse;
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after reparse');
    mmoutput.Lines.Add('---------------------------');
   if ret = 0 then
      mmoutput.Lines.Add(asqlstmt.sqldesc)
   else
      mmoutput.Lines.Add('parse error');


  finally
    asqlstmt.Free;
  end;


end;

procedure Tfrmdemo.Button20Click(Sender: TObject);
var
  ret : integer;
  asqlstmt : TDeleteSqlStatement;
begin
  mminput.Clear;
  mminput.Lines.Text := 'delete from emp'+#13#10+
                        ' where empno = 10';
  mmoutput.Clear;
  asqlstmt := TDeleteSqlStatement.Create(tdbvendor(cbdbvendor.ItemIndex));
  asqlstmt.RawSqlText := mminput.Lines.Text;
  ret := asqlstmt.Parse;
  try
    mmoutput.Lines.Add(asqlstmt.SqlDesc);
    //add table owner
    asqlstmt.Tabletext := 'dept';
    // add a condition to where clause
    asqlstmt.WhereClause.asText := asqlstmt.WhereClause.asText+' or sal between 1000 and 2000';

    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

    asqlstmt.RawSqlText := asqlstmt.SqlDesc;
    ret := asqlstmt.Parse;
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after reparse');
    mmoutput.Lines.Add('---------------------------');
   if ret = 0 then
      mmoutput.Lines.Add(asqlstmt.sqldesc)
   else
      mmoutput.Lines.Add('parse error');


  finally
    asqlstmt.Free;
  end;

end;

procedure Tfrmdemo.Button21Click(Sender: TObject);
var
  ret : integer;
  asqlstmt : TUpdateSqlStatement;
begin
  mminput.Clear;
  mminput.Lines.Text := 'update emp'+#13#10+
                        'set empno=abc,dept_id=20'+#13#10+
                        ' where empno = 10';
  mmoutput.Clear;
  asqlstmt := TUpdateSqlStatement.Create(tdbvendor(cbdbvendor.ItemIndex));
  asqlstmt.RawSqlText := mminput.Lines.Text;
  ret := asqlstmt.Parse;
  try
    mmoutput.Lines.Add(asqlstmt.SqlDesc);
    //add table owner
    asqlstmt.Tabletext := 'dept';
    asqlstmt.SetClauseText := asqlstmt.SetClauseText+',dept_name=aa';
    // add a condition to where clause
    asqlstmt.WhereClause.asText := 'dept_id = 90';

    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

    asqlstmt.RawSqlText := asqlstmt.SqlDesc;
    ret := asqlstmt.Parse;
    mmoutput.Lines.Add('');
    mmoutput.Lines.Add('Sql text after reparse');
    mmoutput.Lines.Add('---------------------------');
   if ret = 0 then
      mmoutput.Lines.Add(asqlstmt.sqldesc)
   else
      mmoutput.Lines.Add('parse error');


  finally
    asqlstmt.Free;
  end;

end;

procedure Tfrmdemo.Button22Click(Sender: TObject);
var
  lcgsqlparser : TGsqlparser;
  ret,i : integer;
  asqlstmt : TSelectSqlStatement;
  lcField : TLzField;
  lcExpr : TLzExpression;
  lcFunc : TLz_FuncCall;
  lcStr : lzstring;
  lcNode ,lcExpr1: TLz_node;
begin
  mmoutput.Clear;
  mminput.clear;
  if tdbvendor(cbdbvendor.ItemIndex) = dbvmysql then
    begin
      showmessage('mysql is not support this function yet, contact info@sqlparser.com for more info');
      exit;
    end;

  mminput.Lines.Add('select convert(abc,1-2,10) as s, a.emp.field2 from emp ');
  lcgsqlparser := TGsqlparser.create(tdbvendor(cbdbvendor.ItemIndex));
  lcgsqlparser.SqlText.Clear;
  lcgsqlparser.SqlText.Add('select convert(abc,1-2,10) as s, a.emp.field2 from emp ');
  ret := lcgsqlparser.Parse;
  try
    if lcgsqlparser.SqlStatements.Count = 0 then exit;
    if lcgsqlparser.SqlStatements[0].SqlStatementType <> sstSelect then exit;
    asqlstmt := TSelectSqlStatement(lcgsqlparser.SqlStatements[0]);
    mmoutput.Lines.Add(asqlstmt.SqlDesc);

    //begin to modify
    lcField := asqlstmt.Fields[0];
    if lcField.FieldType = lftExpression then
      begin
        if lcField.FieldExpr.oper = Expr_FuncCall then
          begin
            lcFunc := TLz_FuncCall(lcField.FieldExpr.lexpr);
            if assigned(lcFunc.args) then
            for i:=0 to lcFunc.args.count -1 do
              begin
                lcExpr1 :=  TLz_node(lcFunc.args[i]);
                lcExpr1.AsText := ''''+lcExpr1.AsText+'''';
              end;

            //delete the second parameters
            if assigned(lcFunc.args) then
             if (lcFunc.args.count > 1) then
              lcFunc.args.remove(1);

            //add a new field with any text you like, even it is illegal
            lcNode := TLz_node.Create(nil);
            lcNode.AsText := 'covert(a to b)';
            if assigned(lcFunc.args) then
              lcFunc.args.Add(lcnode);
          end;
      end;

    lcField := TLzField.Create(nil);
    lcField.FieldName := 'covert(a to b)';
    asqlstmt.Fields.Add(lcField);


    lcField := asqlstmt.Fields[1];
    if lcField.FieldType = lftExpression then
      begin
    //    if lcField.FieldExpr.oper = Expr_Ident then
        lcStr := lcField.FieldExpr.AsText;
        lcField.Fieldname := ''''+lcField.Fieldname+'''';
       lcStr := lcField.FieldExpr.lexpr.AsText;
      end;

    mmoutput.Lines.Add('Sql text after modification');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(asqlstmt.sqldesc);

  finally
    lcgsqlparser.Free;
  end;

end;

procedure Tfrmdemo.Button23Click(Sender: TObject);

function toplevelExpr(pexpr: TLzCustomExpression): lzstring;
begin
  result := '';
  if not assigned(pexpr) then exit;
  if (pExpr.oper = Expr_And) then
    result := toplevelExpr(TLzExpression(pexpr.lexpr))+#13#10+'and '+pexpr.rexpr.AsText
  else if (pExpr.oper = Expr_or) then
    result :=toplevelExpr(TLzExpression(pexpr.lexpr))+#13#10+'or '+result+pexpr.rexpr.AsText
  else
    result := pexpr.AsText;

end;

var
  lcgsqlparser : TGsqlparser;
  ret,i : integer;
  asqlstmt : TSelectSqlStatement;
  lcField : TLzField;
  lcExpr,lcExpr1 : TLzExpression;
  lcFunc : TLz_FuncCall;
  lcStr : lzstring;
begin
  showmessage('check the modify expression tab for more info about expression');
  mmoutput.Clear;
//  mminput.clear;
//  mminput.lines.Add('select field2 from emp where a>b and c>d or e<f ');
  lcgsqlparser := TGsqlparser.create(tdbvendor(cbdbvendor.ItemIndex));
  lcgsqlparser.SqlText.Clear;
  lcgsqlparser.SqlText.Add(mminput.Lines.Text);
  ret := lcgsqlparser.Parse;
  try
    if lcgsqlparser.SqlStatements.Count = 0 then exit;
    if lcgsqlparser.SqlStatements[0].SqlStatementType <> sstSelect then exit;
    asqlstmt := TSelectSqlStatement(lcgsqlparser.SqlStatements[0]);
    mmoutput.Lines.Add(asqlstmt.SqlDesc);

    mmoutput.Lines.Add('top level expression');
    mmoutput.Lines.Add('---------------------------');
    mmoutput.Lines.Add(toplevelExpr(asqlstmt.WhereClause));

  finally
    lcgsqlparser.Free;
  end;
end;

procedure Tfrmdemo.btninspectClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;

  mmerrors.Lines.clear;

  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(mmsqls.Lines);

  agsqlparser.OnSubstitutionVar := testprocess;
  agsqlparser.IsProcessSubstitutionVar := false;
  retries := 0;

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mmerrors.Lines.clear;
     mmerrors.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;

  tvsqlobjects.Items.Clear;
  for sscount := 0 to agsqlparser.SqlStatements.Count - 1 do
     begin
       asql :=  agsqlparser.SqlStatements[sscount];
       if asql.ErrorCount > 0 then
         begin
            mmerrors.Lines.add(asql.errormessages);
         end;
       asql.InspectDBObject;
       DbObjs2TreeView(asql.InspectedDBObjs,tvsqlobjects);
       tvsqlobjects.FullExpand;
     end;

end;

procedure Tfrmdemo.DbObjs2TreeView(dbobjs: TObjectlist; TV: TTreeview);
var
  i,j:integer;
  newNode,newnode2,newnode3,newnode4:TTreeNode;
  str1,str2:lzstring;
  lcdbobj : TLzInspectDBObj;
  dbobjtype : TDBObjType;
begin

  if dbobjs.Count = 0 then exit;
  newNode:=TV.Items.AddChild( nil,'DB Objects' );

  dbobjtype := ttObjUnknown;
  for i:=0 to dbobjs.Count-1 do
  begin
    lcdbobj := TLzInspectDBObj(dbobjs[i]);
    if dbobjtype <> lcdbobj.ObjType then
      begin //add obj type such as table, field
        newNode2:=TV.Items.AddChild( newNode,dbobjtypestr[lcdbobj.ObjType] );
        dbobjtype := lcdbobj.ObjType
      end;
    newNode3:=TV.Items.AddChild( newNode2,lcdbobj.objname ); //add obj name under obj type
    for j:=0 to  lcdbobj.ObjTokens.Count - 1 do  //add token under obj name
      newNode4:=TV.Items.AddChild( newNode3,lcdbobj.ObjTokens[j].sourcecode+' ('+inttostr(lcdbobj.ObjTokens[j].xposition)+','+ inttostr(lcdbobj.ObjTokens[j].yposition)+')');
  end;

end;

procedure Tfrmdemo.BtnParseClick(Sender: TObject);
var
  agsqlparser : Tgsqlparser;
  i,ret:integer;
  s:lzstring;
begin

  agsqlparser := GetCurrentParser;

try

  mmsqlfile.lines.clear;
  agsqlparser.SqlText.clear;
  if rbreadfromfile.Checked then
    begin
      if length(edinputsqlfile.Text) = 0 then
        begin
          showmessage('Input file is not specified!');
          exit;
        end;
      agsqlparser.Sqlfilename := edinputsqlfile.Text;
    end
  else
    agsqlparser.SqlText.assign(reinputsqlstrings.lines);

  if rbsavetofile.Checked then
    begin
      if length(edoutputsqlfile.Text) = 0 then
        begin
          showmessage('output file is not specified!');
          exit;
        end;
      agsqlparser.FormattedSqlfilename := edoutputsqlfile.Text;
    end;

  if rbchecksyntax.Checked then
    begin
      ret := agsqlparser.checksyntax;
    end;

  if rbprettyprint.Checked then
    begin
      ret := agsqlparser.prettyprint;
    end;

  if rbGetclause.Checked then
    begin
      ret := agsqlparser.parsesqlStatements;
    end;

  case ret of
    -1:
      begin
        mmsqlfile.lines.add('Fatal error !');
        mmsqlfile.lines.add(agsqlparser.errormessages)
      end;
    0:
      begin
         if rbchecksyntax.Checked then
           mmsqlfile.lines.add('Check syntax successfully, no syntax error found.');

        if rbprettyprint.Checked then
          if not rbsavetofile.Checked  then
            mmsqlfile.lines.assign(agsqlparser.FormattedSqlText)
          else
            mmsqlfile.lines.add('Formatted SQL were saved to '+edoutputsqlfile.Text);

        if rbGetclause.Checked then
          begin
            showsqlclause(agsqlparser);
          end;

      end;
    else //>0
      begin
      for i:= 1 to agsqlparser.ErrorCount  do
      begin
        with agsqlparser do
          begin
            s := 'Error token: '+SyntaxErrors[i].Token;
            s:=s+'('+inttostr(SyntaxErrors[i].xposition);
            s:=s+','+inttostr(SyntaxErrors[i].yposition)+')';
            s:=s+' Expected token:'+SyntaxErrors[i].hint;
            mmsqlfile.Lines.add(s);
          end;
      end;
      end;
  end;
  mmsqlfile.enabled := true;
 except
 end;

 agsqlparser.FormattedSqlfilename := '';
end;

procedure Tfrmdemo.rbreadfromstringsClick(Sender: TObject);
begin
  edinputsqlfile.Enabled := rbReadfromfile.Checked;
  edinputsqlfile.Color := clMenu;
  btninputfile.Enabled := rbReadfromfile.Checked;
  reinputsqlstrings.Enabled := true;
  reinputsqlstrings.SetFocus;

end;

procedure Tfrmdemo.rbReadfromfileClick(Sender: TObject);
begin
  edinputsqlfile.Enabled := rbReadfromfile.Checked;
  edinputsqlfile.Color := clwindow;
  edinputsqlfile.SetFocus;
  edinputsqlfile.SelectAll;
  btninputfile.Enabled := rbReadfromfile.Checked;
  reinputsqlstrings.Enabled := not rbReadfromfile.Checked;

end;

procedure Tfrmdemo.rbSavetofileClick(Sender: TObject);
begin
 edoutputsqlfile.Enabled := rbSavetofile.Checked;
  edoutputsqlfile.Color := clWindow;
  edoutputsqlfile.SetFocus;
  edoutputsqlfile.SelectAll;
  mmsqlfile.Enabled := not rbSavetofile.Checked;
end;

procedure Tfrmdemo.rbSavetostringsClick(Sender: TObject);
begin
  edoutputsqlfile.Enabled := rbSavetofile.Checked;
  edoutputsqlfile.Color := clMenu;
  mmsqlfile.Enabled := not rbSavetofile.Checked;
  mmsqlfile.SetFocus;
end;

procedure Tfrmdemo.btninputfileClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edinputsqlfile.Text := OpenDialog1.FileName;

  edoutputsqlfile.Text := edinputsqlfile.Text+'.fmt';

end;

procedure Tfrmdemo.showsqlclause(psqlparser: TGsqlparser);
var
  i,j,sscount:integer;
  s1,s2 : lzstring;
  asql : TCustomSqlStatement;
begin
  mmsqlfile.Clear;
        for sscount := 0 to psqlparser.SqlStatements.Count - 1 do
          begin
            asql :=  psqlparser.SqlStatements[sscount];
            case asql.SqlStatementType of
              sstSelect:
                begin
                  mmsqlfile.lines.add(SelectStmtInfo(TSelectSqlStatement(asql)));

                 mmsqlfile.lines.add('');
                 mmsqlfile.lines.add('Raw Select Statement:'+inttostr(sscount));
                 mmsqlfile.lines.add(TSelectSqlStatement(asql).RawSqlText);
                 s1 :=  TSelectSqlStatement(asql).preparedSqlText;
                 mmsqlfile.lines.add('prepared Select Statement:'+inttostr(sscount));
                 mmsqlfile.lines.add(s1);
                 s2 :=  TSelectSqlStatement(asql).Sqldesc;
                 mmsqlfile.lines.add('Select Statement desc:'+inttostr(sscount));
                 mmsqlfile.lines.add(s2);
                end;
              sstInsert:
                begin
                  mmsqlfile.lines.add(InsertStmtInfo(TInsertSqlStatement(asql)));
                end;
              sstUpdate:
                begin
                  mmsqlfile.lines.add(UpdateStmtInfo(TUpdateSqlStatement(asql)));
                end;
              sstDelete:
                begin
                  mmsqlfile.lines.add(DeleteStmtInfo(TDeleteSqlStatement(asql)));
                end;
              sstCreateTable:
                begin
                  mmsqlfile.lines.add('Raw create table Statement:'+inttostr(sscount));
                  mmsqlfile.lines.add(asql.RawSqlText);
                  mmsqlfile.lines.add('create table Statement prepared:'+inttostr(sscount));
                  mmsqlfile.lines.add(TsqlpluscmdStatement(asql).preparedsqltext);
                end;
              sstSqlplusCmd:
                begin
                  mmsqlfile.lines.add('Raw sqlplus Statement:'+inttostr(sscount));
                  mmsqlfile.lines.add(asql.RawSqlText);
                  mmsqlfile.lines.add('sqlplus Statement prepared:'+inttostr(sscount));
                  mmsqlfile.lines.add(TsqlpluscmdStatement(asql).preparedsqltext);
                end;
              sstAlterSession:
                begin
                  s1 := asql.rawsqltext;
                  mmsqlfile.lines.add('--- alter session statement:------------------');
                  mmsqlfile.lines.add(s1);
                end;
              sstplsql_block:
                begin
                  s1 := asql.rawsqltext;
                  mmsqlfile.lines.add('--- plsql block:------------------');
                  mmsqlfile.lines.add(s1);
                end;
              sstUnknown:
                begin
                  s1 := TUnknownSqlStatement(asql).rawsqltext;
                  mmsqlfile.lines.add('---unknown sql statement:------------------');
                  mmsqlfile.lines.add(s1);
                end;
              else ;
            end;
          end;


end;

{ TLzParseTree2XMLVisitor }

constructor TLzParseTree2XMLVisitor.Create;
begin
  inherited Create;
  XmlStr := '';

end;

procedure TLzParseTree2XMLVisitor.Execute(const pVisited: TLzVisitedAbs);
var
  lcstr : lzstring;
begin
  inherited Execute(pVisited);
  if pVisited is TSourceToken then
    begin
      lcstr  := (pVisited as TSourceToken).AsText;
//      StrReplace(lcstr,'<','&lt;',[rfReplaceAll]);
      xmlstr := xmlstr+' '+lcstr;
    end;

end;

procedure TLzParseTree2XMLVisitor.PostExecute(
  const pVisited: TLzVisitedAbs);
begin
  xmlstr := xmlstr+linebreak+'</'+pVisited.ClassName+'_level'+inttostr(depth)+'>';
end;

procedure TLzParseTree2XMLVisitor.PreExecute(
  const pVisited: TLzVisitedAbs);
begin
  xmlstr := xmlstr+linebreak+'<'+pVisited.ClassName+'_level'+inttostr(depth)+'>';
end;

function TLzParseTree2XMLVisitor.Visit: integer;
begin
  if not assigned(ParseTree) then exit;
  XmlStr := '<?xml version="1.0" ?>';
  parsetree.Iterate(self);
end;

procedure Tfrmdemo.Button4Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  agsqlparser : TGsqlparser;
  lcstmt : TSelectSqlStatement;
begin

  agsqlparser := GetCurrentParser;

  memo2.Lines.clear;

  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(memo1.Lines);

  agsqlparser.OnSubstitutionVar := testprocess;
  agsqlparser.IsProcessSubstitutionVar := false;
  retries := 0;

  ret := agsqlparser.parse;


  if agsqlparser.ErrorCount > 0 then
    begin
     memo2.Lines.clear;
     memo2.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;
  if agsqlparser.SqlStatements.Count = 0 then exit;
  if agsqlparser.SqlStatements[0].SqlStatementType <> sstSelect then exit;
  lcstmt := agsqlparser.SqlStatements[0] as  TSelectSqlStatement;


   if assigned(lcstmt.WhereClause) then
   begin
    lcstmt.WhereClause.GetInvolvedDbObjects;
    memo2.lines.add('Involved Tables:');
    for i:=0 to lcstmt.WhereClause.tabletokens.count -1 do
      memo2.lines.Add(lcstmt.WhereClause.tabletokens[i].astext);
    memo2.lines.add('--------------------');
    memo2.lines.add('Involved Fields:');
    for i:=0 to lcstmt.WhereClause.fieldtokens.count -1 do
      memo2.lines.Add(lcstmt.WhereClause.fieldtokens[i].astext);
   end;

end;

procedure Tfrmdemo.Button5Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;

  try
    agsqlparser.SqlText.Assign(mm1.Lines);
    i := agsqlparser.Parse;
    if i <> 0 then
      showmessage(agsqlparser.ErrorMessages)
    else
      begin
        if agsqlparser.SqlStatements[0].SqlStatementType = sstSelect then
          begin
            getjointable(tv1,TSelectSqlStatement(agsqlparser.SqlStatements[0]).joinTables);
            getjointableorderbyqual(tv2,TSelectSqlStatement(agsqlparser.SqlStatements[0]).joinTables);
          end;
      end;
  finally
  end;

end;

procedure Tfrmdemo.addallsubjoinitems(pctv: TTreeView; pcnode: TTreeNode;
  pcJoinItems: TLzJoinItemList; pmParentId: integer);
var
  i:Integer;
  MyTreeNode2,MyTreeNode3: TTreeNode;
  lcJoinItem : TLzJoinItem;
begin
  for i:=0 to pcJoinItems.Count - 1 do
    begin
      lcJoinItem := pcJoinItems[i];
      if lcJoinItem.ParentId = pmParentId then
        begin
          MyTreeNode3 := pctv.items.AddChild(pcnode, 'item'+inttostr(i+1));
          getjoinitemobq(pctv,MyTreeNode3,lcJoinItem);
          addallsubjoinitems(pctv,MyTreeNode3,pcJoinItems,i+1);
        end;
    end;

end;

procedure Tfrmdemo.getjoin(pctv: TTreeView; pcnode: TTreeNode;
  pcJoin: TLzJoin);
var
  MyTreeNode: TTreeNode;
begin
    pctv.items.AddChild(pcnode,'Nested Level: '+inttostr(pcJoin.NestedLevel));
    pctv.items.AddChild(pcnode,'Alias: '+pcJoin.Alias);
    if pcJoin.AliasWithAs then
      pctv.items.AddChild(pcnode,'Alias with as: true')
    else
      pctv.items.AddChild(pcnode,'Alias with as: false');

    case pcJoin.JoinTableType of
      jttNone:
        pctv.items.AddChild(pcnode,'Table:'+pcJoin.JoinTable.AsText);
      jttTable:
        begin
          pctv.items.AddChild(pcnode,'Table:'+pcJoin.JoinTable.AsText);
        end;
      jttJoin:
        begin
          MyTreeNode := pctv.items.AddChild(pcnode, 'join');
          getjoin(pctv,MyTreeNode,pcJoin.JoinJoin);
        end;
    end;//case

   getjoinitems(pctv,pcnode,pcJoin.JoinItems);

end;

procedure Tfrmdemo.getjoinitem(pctv: TTreeView; pcnode: TTreeNode;
  pcJoinItem: TLzJoinItem);
var
  j:Integer;
  MyTreeNode: TTreeNode;
  sjt:lzstring;
begin
  //JoinType
  case pcJoinItem.JoinType of
    sjtCross: sjt := 'join cross';
    sjtNatural : sjt := 'join natural';
    sjtjoininner: sjt:= 'join default';
    sjtfull: sjt := 'join full';
    sjtLeft: sjt := 'join left';
    sjtright: sjt := 'join right';
    sjtfullouter: sjt := 'join full outer';
    sjtleftouter: sjt := 'join left outer';
    sjtrightouter: sjt := 'join right outer';
   // sjtinnerouter: sjt := 'join inner';
  end;
  MyTreeNode := pctv.items.AddChild(pcnode, 'join type:'+sjt);
  if pcJoinItem.JoinQualType = sjqOn then
    MyTreeNode := pctv.items.AddChild(pcnode, 'join qual type: on')
  else
    MyTreeNode := pctv.items.AddChild(pcnode, 'join qual type: using');
  if pcJoinItem.JoinItemTableType = jttTable then
    MyTreeNode := pctv.items.AddChild(pcnode, 'join table: '+pcJoinItem.JoinItemTable.AsText)
  else
    begin
      MyTreeNode := pctv.items.AddChild(pcnode, 'join');
      getjoin(pctv,MyTreeNode,pcJoinItem.JoinItemJoin);
    end;
  MyTreeNode := pctv.items.AddChild(pcnode, 'join qual:'+pcJoinItem.JoinQual.AsText);

end;

procedure Tfrmdemo.getjoinitemobq(pctv: TTreeView; pcnode: TTreeNode;
  pcJoinItem: TLzJoinItem);
var
  j:Integer;
  MyTreeNode: TTreeNode;
  sjt:lzstring;
begin
  //JoinType
  case pcJoinItem.JoinType of
    sjtCross: sjt := 'join cross';
    sjtNatural : sjt := 'join natural';
    sjtjoininner: sjt:= 'join default';
    sjtfull: sjt := 'join full';
    sjtLeft: sjt := 'join left';
    sjtright: sjt := 'join right';
    sjtfullouter: sjt := 'join full outer';
    sjtleftouter: sjt := 'join left outer';
    sjtrightouter: sjt := 'join right outer';
    //sjtinnerouter: sjt := 'join inner';
  end;
  MyTreeNode := pctv.items.AddChild(pcnode, 'join type:'+sjt);
  if pcJoinItem.JoinQualType = sjqOn then
    MyTreeNode := pctv.items.AddChild(pcnode, 'join qual type: on')
  else
    MyTreeNode := pctv.items.AddChild(pcnode, 'join qual type: using');
  if pcJoinItem.JoinItemTableType = jttTable then
    MyTreeNode := pctv.items.AddChild(pcnode, 'join table: '+pcJoinItem.JoinItemTable.AsText)
  else
    begin
      MyTreeNode := pctv.items.AddChild(pcnode, 'join');
      getjoinobq(pctv,MyTreeNode,pcJoinItem.JoinItemJoin);
    end;
  MyTreeNode := pctv.items.AddChild(pcnode, 'join qual:'+pcJoinItem.JoinQual.AsText);

end;

procedure Tfrmdemo.getjoinitems(pctv: TTreeView; pcnode: TTreeNode;
  pcJoinItems: TLzJoinItemList);
var
  j:Integer;
  MyTreeNode2,MyTreeNode3: TTreeNode;
begin
  MyTreeNode2 := pctv.items.AddChild(pcnode, 'Join item');
  for j:=0 to pcJoinItems.Count - 1 do
    begin
      MyTreeNode3 := pctv.items.AddChild(MyTreeNode2, 'item'+inttostr(j+1));
      getjoinItem(pctv,MyTreeNode3,pcJoinItems[j]);
    end;

end;

procedure Tfrmdemo.getjoinObq(pctv: TTreeView; pcnode: TTreeNode;
  pcJoin: TLzJoin);
var
  MyTreeNode,MyTreeNode2: TTreeNode;
  i:Integer;
  lcJoinItem : TLzJoinItem;
begin
    pctv.items.AddChild(pcnode,'Nested Level: '+inttostr(pcJoin.NestedLevel));
    pctv.items.AddChild(pcnode,'Alias: '+pcJoin.Alias);
    if pcJoin.AliasWithAs then
      pctv.items.AddChild(pcnode,'Alias with as: true')
    else
      pctv.items.AddChild(pcnode,'Alias with as: false');

    case pcJoin.JoinTableType of
      jttNone:
        pctv.items.AddChild(pcnode,'Table:'+pcJoin.JoinTable.AsText);
      jttTable:
        begin
          pctv.items.AddChild(pcnode,'Table:'+pcJoin.JoinTable.AsText);
        end;
      jttJoin:
        begin
          MyTreeNode := pctv.items.AddChild(pcnode, 'join');
          getjoinobq(pctv,MyTreeNode,pcJoin.JoinJoin);
        end;
    end;//case

    MyTreeNode2 := pctv.items.AddChild(pcnode, 'Sub join item');
    addallsubjoinitems(pctv,MyTreeNode2,pcJoin.JoinItems,0);

end;

procedure Tfrmdemo.getjointable(pctv: TTreeView; pcJoins: TLzJoinList);
var
  i,j:Integer;
  MyTreeNode1 : TTreeNode;
  lcJoin : TLzJoin;
begin
  pctv.items.clear;
  MyTreeNode1 := pctv.items.Add(nil, 'Join table demo');
  for i:=0 to pcJoins.Count - 1 do
    begin
      lcJoin := pcJoins.Items[i];
      getjoin(pctv,MyTreeNode1,lcJoin);
    end;

end;

procedure Tfrmdemo.getjointableOrderbyQual(pctv: TTreeView;
  pcJoins: TLzJoinList);
var
  i,j:Integer;
  MyTreeNode1 : TTreeNode;
  lcJoin : TLzJoin;
begin
  pctv.items.clear;
  MyTreeNode1 := pctv.items.Add(nil, 'Join table demo(Order according to Qual)');
  for i:=0 to pcJoins.Count - 1 do
    begin
      lcJoin := pcJoins.Items[i];
      lcJoin.RefreshOrderOfJoinItem;
      getjoinobq(pctv,MyTreeNode1,lcJoin);
    end;

end;

procedure Tfrmdemo.btnfindvariableClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;

  memo4.Clear;

  agsqlparser.SqlText.assign(memo3.Lines);
  agsqlparser.OnSubstitutionVar := simplexprocess;
  agsqlparser.onbindvar := BindVarTestProcess1;
  agsqlparser.onsqlvar := VarTestProcess1;

  ret := agsqlparser.parse;

    if  ret <> 0 then
    begin
      if agsqlparser.ErrorCount > 0 then
        begin
         memo4.Lines.clear;
         memo4.Lines.add(agsqlparser.errormessages);
        end;
      if ret < 0 then exit;
    end;

        memo4.lines.clear;
        //agsqlparser.GetSqlStatements;
        for i := 0 to agsqlparser.SqlStatements.Count - 1 do
          begin
            asql :=  agsqlparser.SqlStatements[i];
            if asql.Params.Count > 0 then
              begin
                lcStr := 'Bind variables:';
                for j:=0 to asql.Params.Count - 1 do
                  lcStr := lcStr+#13#10+'Name: '+asql.Params[j].ValueName+ ' Value:'+asql.Params[j].ValueStr
              end;
            memo4.lines.add(lcStr);

            if asql.SqlVars.Count > 0 then
            begin
              memo4.Lines.Add(#13#10+'sql variables:');
              for j:=0 to asql.SqlVars.Count - 1 do
                memo4.Lines.Add(asql.SqlVars[j].SourceToken.astext);
            end;

//                 memo4.lines.add('');
//                 memo4.lines.add('Raw Select Statement:'+inttostr(i));
//                 memo4.lines.add(asql.RawSqlText);
//                 memo4.lines.add('prepared Select Statement:'+inttostr(i));
//                 memo4.lines.add(asql.preparedSqlText);
//                 memo4.lines.add('Select Statement desc:'+inttostr(i));
//                 memo4.lines.add(asql.Sqldesc);
          end;
end;

procedure Tfrmdemo.simplexprocess(
  aSubstitutionVarList: TSubstitutionVarList);
var
  i:Integer;
begin
  for i:=0 to aSubstitutionVarList.Count -1 do
    begin
      aSubstitutionVarList[i].VarValue := InputBox('Input Box', 'Input value for substitution variable:', '');
      //showmessage(aSubstitutionVarList[i].VarName);
    end;

end;

procedure Tfrmdemo.BindVarTestProcess1(owner: TObject;
   const bindvarname: lzstring;
  var replacestr: lzstring);
begin
//  Showmessage('Bind Variable '+bindvarname+' is found');

  replacestr := InputBox('Input Box for bind variable', 'Input value for bind variable: '+bindvarname, '');
end;

procedure Tfrmdemo.Button7Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;


  memo6.lines.clear;
  agsqlparser.SqlText.Clear;
  agsqlparser.SqlText.Text := memo5.Lines.Text;

  agsqlparser.onstatementfield := nil;
  agsqlparser.onstatementtable := nil;
  agsqlparser.OnTokenlizerToken := nil;
  agsqlparser.OnGetRawSqlStatement := nil;
  agsqlparser.OnParserToken := nil;
  agsqlparser.OnParserTokenError := nil;

  if cbonTokenlizerToken.Checked then
    agsqlparser.OnTokenlizerToken := On_TokenlizerToken1;


  if cbOnGetRawSqlStatement.Checked then
    agsqlparser.OnGetRawSqlStatement := On_GetRawSqlStatement1;

  retries := 0;
  kwcount := 0;
  identcount := 0;
  stringcount := 0;
  numbercount := 0;
  singlecharcount := 0;
  multicharcount := 0;
  bindvarcount := 0;
  WhiteSpacecount := 0;
  returncount := 0;
  commentcount := 0;
  unknowncharcount := 0;


  ret := agsqlparser.parse;

  if  ret <> 0 then
    begin
      if agsqlparser.ErrorCount > 0 then
        begin
         memo6.Lines.clear;
         memo6.Lines.add(agsqlparser.errormessages);
        end;
      if ret < 0 then exit;
    end;

 //show character information collected from On_TokenlizerToken
 if cbOnTokenlizerToken.Checked then
 showmessage(format(' keywords: %d %s identifier: %d %s lzstring: %d %s number: %d %s single char: %d %s '+
 'multi char: %d %s return: %d %s whitespace: %d %s comment: %d %s unknown char: %d',
 [kwcount,#13#10,identcount,#13#10,stringcount,#13#10,numbercount,#13#10,
 singlecharcount,#13#10,multicharcount,#13#10,returncount,#13#10,WhiteSpacecount,#13#10,
 commentcount,#13#10,unknowncharcount]));

end;

procedure Tfrmdemo.On_ParserToken(sender: TObject;
  var pToken : TSourceToken ;const pDbVendor : integer);
var
  lcprev,lcnext : TSourceToken;
  i : integer;
begin

  if not assigned(pToken) then exit;
  if not assigned(pToken.Container) then exit;
  if compareText(pToken.SourceCode,'table') = 0 then
    begin
      lcprev := pToken.Container.NextSolidToken(pToken,-1);
      if assigned(lcprev) then
        if compareText(lcprev.SourceCode,'from') = 0 then
          begin
            i := pToken.TokenCode;
            pToken.TokenCode := IDENT;
            if TDbVendor(pDBVendor) = DBVOracle then
              begin //avoid situation like : from table(..) , this is valid in oracle
                lcnext := pToken.Container.NextSolidToken(pToken);
                if assigned(lcnext) then
                  if compareText(lcnext.SourceCode,'(') = 0 then
                    pToken.TokenCode := i;
              end;
          end;
    end;

end;

procedure Tfrmdemo.On_ParserTokenError(sender: TObject;
  var pToken : TSourceToken ;const pDbVendor : integer;
  const pExpectedTokens: lzstring; var pAction: TActionOnParseError;
  var pRollbackTokens : integer;var pRollbackState: Boolean);
var
  lcToken : TSourceToken;
begin

  showmessage(format(' error token: %s %s expected token: %s',[pToken.SourceCode,#13#10,pExpectedTokens]));
  if TDbVendor(pdbvendor) <> dbvoracle then
    begin
      pRollbackTokens := 1;
      pToken.TokenCode := IDENT;
    end
  else
    begin
      pRollbackState := true;
      pRollbackTokens := 2;
      lcToken := pToken.container.NextSolidToken(pToken,-1);
      if assigned(lcToken) then
        lcToken.TokenCode := IDENT;
    end;
//  pRollbackOneToken := cbrollbackonetoken.Checked;
//  asqlstatement.InsertStrToSourcetokenList(pCurPos+1,' '+edinsertstr.Text);
  inc(retries);
  if retries > 5 then
    pAction := aopAbort
  else
    pAction := aopContinue;

end;



procedure Tfrmdemo.On_TokenlizerToken1(sender: TObject;
  const st: TSourceToken);
begin

  case st.TokenType of
    ttKeyword: begin inc(kwcount); end;
    ttIdentifier,ttDQString : inc(identcount);
    ttNumber : inc(numbercount);
    ttSQString : inc(stringcount);
    ttWhitespace : inc(whitespacecount);
    ttReturn : inc(returncount);
    ttDoublehyphenComment,ttSlashStarComment : inc(commentcount);
    else
      begin
        if st.TokenType in ttsSingleChar then inc(singlecharcount)
        else if st.TokenType in ttsMultiChar then inc(multicharcount)
        else  inc(unknowncharcount);
      end;
  end;

end;

procedure Tfrmdemo.On_TokenlizerTokenError1(sender: TObject;
  const st: TSourceToken);
begin
  showmessage('On Tokenlizer token error:'+st.SourceCode);
end;

procedure Tfrmdemo.On_GetRawSqlStatement1(sender : TObject; Const sqltype: TSqlStatementType; Const StartPos,EndPos : integer);
begin
  showmessage('sql found');
end;

procedure Tfrmdemo.btnTolangClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  varname,lcresult:lzstring;
  ss : Boolean;
  lcse: TLzScriptExplorer;
  lccvt : tlzlangconverter;
begin

  agsqlparser := GetCurrentParser;

  sqloutput.lines.clear;

  agsqlparser.SqlText.assign(sqlinput.Lines);
  ret := agsqlparser.Parse;
  if ret <> 0 then
    begin
      sqloutput.text :=  agsqlparser.ErrorMessages;
      exit;
    end;

  lccvt := tlzlangconverter.create(agsqlparser);

  try

  case TOutputFmt(cmblanguages.ItemIndex) of    //
    ofsql: ;
    ofCsharp:
      sqloutput.Text := lccvt.ToCSharp('var');
    ofCsharpsbd:
      sqloutput.Text := lccvt.ToCSharpStringBuilder('var') ;
    ofvb:
      sqloutput.Text := lccvt.ToVb('var');
    ofvbsbd:
      sqloutput.Text := lccvt.ToVbStringBuilder('var');
    ofjava:
      sqloutput.Text := lccvt.ToJava('var');
    ofjavasbf:
      sqloutput.Text := lccvt.ToJavaStringBuffer('var');
    ofvc:
      sqloutput.Text := lccvt.ToVc('var');
    ofpascal:
      sqloutput.Text := lccvt.ToPascal('var');
    ofphp:
      sqloutput.Text := lccvt.ToPhp('var');
    ofproc:
      sqloutput.Text := lccvt.ToProc('var');
    ofprocobol:
      sqloutput.Text := lccvt.ToProCobol('var');
{
    ofhtml:
      sqloutput.Text := lccvt.ToHtml('');
    ofhtml2:
      sqloutput.Text := lccvt.ToHtml2('');
    ofhtmlkeeplayout:
      sqloutput.Text := lccvt.ToHtmlKeepLayout(ofhtml,false);
    ofhtmlkeeplayout2:
      sqloutput.Text := lccvt.ToHtmlKeepLayout(ofhtml2,false);
    ofhtmlkeeplayoutmodifycase:
      sqloutput.Text := lccvt.ToHtmlKeepLayout(ofhtml,true);
    ofhtmlkeeplayout2modifycase:
      sqloutput.Text := lccvt.ToHtmlKeepLayout(ofhtml2,true);
}
    oftxtmodifycase:
       sqloutput.Text := lccvt.ToTextModifyCaseOnly;
    ofxml:
      sqloutput.Text := agsqlparser.XmlText;
    ofdbobject:
      begin
        lcse := TLzScriptExplorer.Create(nil);
        try
          lcse.sqlstatements := agsqlparser.SqlStatements;
          lcse.AnalyzeScript;
          lcse.FlattenDBList;
          sqloutput.Text := lcse.getObjectInfoInList;
        finally
          lcse.free;
        end;

      end;
  end;    // case

  finally
    lccvt.free;
  end;

end;

procedure Tfrmdemo.btngo1Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;


  agsqlparser.SqlText.Clear;
  agsqlparser.SqlText.Text := 'select field1 from table';

  agsqlparser.onstatementfield := nil;
  agsqlparser.onstatementtable := nil;
  agsqlparser.OnTokenlizerToken := nil;
  agsqlparser.OnGetRawSqlStatement := nil;
  agsqlparser.OnParserToken := nil;
  agsqlparser.OnParserTokenError := nil;


  if cbOnParserToken.Checked then
    agsqlparser.OnParserToken := On_ParserToken;

  if cbOnParserTokenError.Checked then
    agsqlparser.OnParserTokenError := On_ParserTokenError;


  ret := agsqlparser.prettyprint;


  memo6.Lines.clear;
  if  ret <> 0 then
    begin
      if agsqlparser.ErrorCount > 0 then
         memo6.Lines.add(agsqlparser.errormessages);
    end
  else
    memo6.lines.add(agsqlparser.FormattedSqlText.Text);

end;

procedure Tfrmdemo.btngo2Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;


  memo6.lines.clear;
  agsqlparser.SqlText.Clear;
  agsqlparser.SqlText.Text := memo5.Lines.Text;

  agsqlparser.onstatementfield := nil;
  agsqlparser.onstatementtable := nil;
  agsqlparser.OnTokenlizerToken := nil;
  agsqlparser.OnGetRawSqlStatement := nil;
  agsqlparser.OnParserToken := nil;
  agsqlparser.OnParserTokenError := nil;
  agsqlparser.OnTableToken := nil;
  agsqlparser.OnFieldToken := nil;

  if cbonStatementField.Checked then
    agsqlparser.OnTableToken := MyOnTableToken;

  if cbonStatementTable.Checked then
    agsqlparser.OnFieldToken := MyOnFieldToken;

  mytablelist := TStringlist.Create;
  myFieldlist := TStringlist.Create;

  try

  retries := 0;

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mmerrors.Lines.clear;
     mmerrors.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;

  memo6.Lines.clear;

  memo6.Lines.Add('Table');
  for i:=0 to mytablelist.Count - 1 do
     memo6.Lines.Add(mytablelist[i]);
  memo6.Lines.Add('------------');
  memo6.Lines.Add('Field');
  for i:=0 to myfieldlist.Count - 1 do
     memo6.Lines.Add(myfieldlist[i]);
 finally
   mytablelist.Free;
   myfieldlist.Free;
   agsqlparser.OnTableToken := nil;
   agsqlparser.OnFieldToken := nil;
 end;

end;


procedure Tfrmdemo.btnInspectbyEventClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
begin

  agsqlparser := GetCurrentParser;

  mmerrors.Lines.clear;
  mminspectedobjs.Lines.clear;
  
  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(mmsqls.Lines);

  mytablelist := TStringlist.Create;
  myFieldlist := TStringlist.Create;
  try
  agsqlparser.OnTableToken := MyOnTableToken_replacetable;
  agsqlparser.OnFieldToken := nil;
  retries := 0;

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mmerrors.Lines.clear;
     mmerrors.Lines.add(agsqlparser.errormessages);
    end;

  if ret <> 0 then exit;

  mminspectedobjs.Lines.Add('All tables were replaced by view_oldtablename'+#13#10);
  for i:=0 to agsqlparser.SqlStatements.Count - 1 do
     mminspectedobjs.Lines.Add(agsqlparser.SqlStatements[i].astext+#13#10);

 finally
   mytablelist.Free;
   myfieldlist.Free;
   agsqlparser.OnTableToken := nil;
   agsqlparser.OnFieldToken := nil;
 end;

end;

procedure Tfrmdemo.MyOnFieldToken(Sender: Tobject; pToken: TSourceToken;
  psqlstatement: TCustomSqlStatement);
var
  lcstr : lzstring;
begin
  if psqlstatement.Tables.Count> 0 then
    lcstr := '('+psqlstatement.Tables[0].tablename+')'
  else
    lcstr := '( table )';
  myFieldlist.Add(pToken.SourceCode+lcstr);

end;

procedure Tfrmdemo.MyOnTableToken(Sender: Tobject; pToken: TSourceToken;
  psqlstatement: TCustomSqlStatement);
var
  lcstr : lzstring;
begin
  if psqlstatement.Tables.Count> 0 then
    lcstr := '('+psqlstatement.Tables[0].tablename+')'
  else
    lcstr := '('+ pToken.SourceCode+ ')';
  myTablelist.Add(pToken.SourceCode+lcstr);

end;

procedure Tfrmdemo.VarTestProcess1(owner: TObject; const varname: lzstring;
  var replacestr: lzstring);
begin
  Showmessage('Variable '+varname+' is found');
end;

{ TLzParseTreeVisitor }

constructor TLzParseTreeVisitor.Create;
begin
  inherited;
  ParseTree := nil;
end;

procedure TLzParseTreeVisitor.Execute(const pVisited: TLzVisitedAbs);
var
  lcstr : lzstring;
  lctk : TSourceToken;
begin
// deal leaf node(TSourceToken here)
  inherited Execute(pVisited);
  if pVisited is TSourceToken then
    begin
      lctk  := pVisited as TSourceToken;
      if lctk.TokenType in [ttSQString] then
        lctk.SourceCode := '?';
    end;

end;

procedure TLzParseTreeVisitor.PostExecute(const pVisited: TLzVisitedAbs);
begin
  inherited;

end;

procedure TLzParseTreeVisitor.PreExecute(const pVisited: TLzVisitedAbs);
begin
  inherited;
 // add your code here to deal with non-leaf parse tree node(all nodes except TSourceToken
 // are non-leaf parse tree nodes
end;

function TLzParseTreeVisitor.Visit: integer;
begin
  if not assigned(ParseTree) then exit;
  parsetree.Iterate(self);
end;

procedure Tfrmdemo.Button1Click(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  lcvisitor : TLzParseTreeVisitor;
begin

  agsqlparser := GetCurrentParser;


  memo8.lines.clear;
  agsqlparser.SqlText.assign(memo7.Lines);

  ret := agsqlparser.parse;
  lcvisitor := TLzParseTreeVisitor.Create;
  try

  if agsqlparser.ErrorCount > 0 then
    begin
     memo8.Lines.clear;
     memo8.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;

  for sscount := 0 to agsqlparser.SqlStatements.Count - 1 do
     begin
       asql :=  agsqlparser.SqlStatements[sscount];
       if assigned(asql.WhereClause) then
         begin
           lcvisitor.ParseTree := asql;
           lcvisitor.visit;
         end;
       memo8.Lines.Add(asql.AsText);
     end;

 finally
   lcvisitor.Free;
 end;

end;

procedure Tfrmdemo.btnbuildsqlClick(Sender: TObject);
var
  lcsql : lzstring; //widestring
begin
   mmbuildsql.Lines.Clear;

   buildbasicelement(lcsql);
   mmbuildsql.Lines.add('basic element:');
   mmbuildsql.Lines.add(lcsql);

   buildfieldconstraint(lcsql);
   mmbuildsql.Lines.add('field constraint:');
   mmbuildsql.Lines.add(lcsql);

   buildtableconstraint(lcsql);
   mmbuildsql.Lines.add('table constraint');
   mmbuildsql.lines.add(lcsql);

   buildfield(lcsql);
   mmbuildsql.Lines.add('field');
   mmbuildsql.lines.add(lcsql);

   buildtable(lcsql);
   mmbuildsql.Lines.add('table');
   mmbuildsql.lines.add(lcsql);

   buildaltertableMySQL(lcsql,dbvmysql);
   mmbuildsql.Lines.add('alter table');
   mmbuildsql.lines.add(lcsql);

   buildselect(lcsql);
   mmbuildsql.Lines.add('select');
   mmbuildsql.lines.add(lcsql);

   builddelete(lcsql);
   mmbuildsql.Lines.add('delete');
   mmbuildsql.lines.add(lcsql);

   buildupdate(lcsql);
   mmbuildsql.Lines.add('update');
   mmbuildsql.lines.add(lcsql);

   buildinsert(lcsql);
   mmbuildsql.Lines.add('insert');
   mmbuildsql.lines.add(lcsql);

   buildinsertmysql(lcsql,dbvmysql);
   mmbuildsql.Lines.add('myql insert');
   mmbuildsql.lines.add(lcsql);

   buildcreatetable(lcsql);
   mmbuildsql.Lines.add('create table');
   mmbuildsql.lines.add(lcsql);

   buildcreatetablemysql(lcsql,dbvmysql);
   mmbuildsql.Lines.add('mysql create table');
   mmbuildsql.lines.add(lcsql);

end;

procedure Tfrmdemo.btnexprgetdbobjClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asql : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  expr : TlzCustomExpression;
begin

  agsqlparser := GetCurrentParser;

  mmerrors.Lines.clear;
  mminspectedobjs.Lines.clear;

  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(mmsqls.Lines);

  agsqlparser.OnSubstitutionVar := testprocess;
  agsqlparser.IsProcessSubstitutionVar := false;
  retries := 0;

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mmerrors.Lines.clear;
     mmerrors.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;
  for sscount := 0 to agsqlparser.SqlStatements.Count - 1 do
     begin
       if agsqlparser.SqlStatements[sscount].SqlStatementType <> sstselect then continue;


       asql :=  agsqlparser.SqlStatements[sscount] as TSelectSqlStatement;

       if not assigned(asql.whereclause) then
         begin
           mminspectedobjs.lines.add('No where clause found!');
           continue;
         end;

       Expr := asql.whereclause;
       expr.GetInvolvedDbObjects;

       mminspectedobjs.lines.add('table tokens:');
       for i:=0 to expr.TableTokens.Count - 1 do
         begin
           mminspectedobjs.lines.add(expr.TableTokens[i].AsText);
           expr.TableTokens[i].AsText := '';
         end;

       mminspectedobjs.lines.add('field tokens:');
       for i:=0 to expr.FieldTokens.Count - 1 do
         mminspectedobjs.lines.add(expr.FieldTokens[i].astext);

     end;

end;

procedure Expr2TreeView(pcExpr : TLzCustomExpression;TV: TTreeview);
    var
      node :TTreeNode;
      lcstr : lzstring;

    procedure ReadExpr(Root:TTreeNode; pcExpr1 : TLzCustomExpression);
      var i,k:integer; newNode,newNode2:TTreeNode;
      str1:lzstring;
    begin

      pcExpr1.FlattenExpr;
      for i:=0 to pcExpr1.ChildNodes.Count-1 do
      begin
       str1 :=  (pcExpr1.ChildNodes[i] as TLz_node ).AsText;

       lcstr := format('%.20s',[str1]);
       if length(str1) > 20 then
        lcstr := lcstr+'...';

       newNode:=TV.Items.AddChild( Root,lcstr );
       newNode.Data :=  pcExpr1.ChildNodes[i];

       if (pcExpr1.ChildNodes[i] as TLz_node ).Nodetype = T_Expr then
         ReadExpr(newNode,pcExpr1.ChildNodes[i] as TLzCustomExpression)
       else if (pcExpr1.ChildNodes[i] as TLz_node ).Nodetype = T_list then
         for k:=0 to  (pcExpr1.ChildNodes[i] as TLz_list).count - 1 do
           begin
             str1 := ((pcExpr1.ChildNodes[i] as TLz_list)[k] as TLzCustomExpression).Astext;
             lcstr := format('%.20s',[str1]);
             if length(str1) > 20 then
               lcstr := lcstr+'...';
             newNode2:=TV.Items.AddChild( newNode,lcstr );
             newNode2.Data :=  (pcExpr1.ChildNodes[i] as TLz_list)[k];
             ReadExpr(newNode2,( (pcExpr1.ChildNodes[i] as TLz_list)[k] as TLzCustomExpression));
           end;
      end;
    end;

  begin
    lcstr := format('%.20s',[pcExpr.AsText]);
    if length(pcExpr.AsText) > 20 then
      lcstr := lcstr+'...';
    node := TV.Items.AddChild( nil,lcstr );
    node.Data := pcExpr;
    ReadExpr( node , pcExpr);
  end;


procedure Tfrmdemo.btnflattenexprClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
//  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  Expr : TLzCustomExpression;


begin

  agsqlparser := GetCurrentParser;

  sqloutput.Lines.clear;
  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(memo9.Lines);

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     sqloutput.Lines.clear;
     sqloutput.Lines.add(agsqlparser.errormessages);
    end;

  if ret < 0 then exit;
  if agsqlparser.SqlStatements.Count = 0 then exit;
  asql :=  agsqlparser.SqlStatements[0];
  if not assigned(asql.WhereClause) then exit;
  expr := asql.WhereClause;


  treeview2.Items.Clear;
  Expr2TreeView(expr,treeview2);
  
end;

procedure Tfrmdemo.TreeView2Click(Sender: TObject);
var
  lcNode : Tlz_node;
begin
 if assigned(treeview2.Selected) then
   if assigned(treeview2.Selected.Data) then
     begin
       lcNode  := TLz_node(treeview2.Selected.Data );
       memo10.Lines.clear;
       memo10.Lines.add(lcNode.astext+'('+OperatorStr[lcNode.ExprTag]+')');
     end;
end;

procedure Tfrmdemo.btnsetnewvalueClick(Sender: TObject);
var
  lcNode,root : Tlz_node;
begin

 if assigned(treeview2.Selected) then
   if assigned(treeview2.Selected.Data) then
     begin
       lcNode  := TLz_node(treeview2.Selected.Data );
       lcNode.astext := ednewexprvalue.Text;

       //top level expression
       Root := treeview2.items[0].data;
       memo10.Lines.clear;
       memo10.Lines.add(Root.astext);


       if (Root as TlzCustomExpression).ParseAsText(Root.astext) then
         begin
           treeview2.Items.Clear;
           Expr2TreeView(Root as TlzCustomExpression,treeview2);
           // rebuild whole sql after set the new expr value
           if assigned(asql) then
             begin
               memo9.Lines.Clear;
               memo9.Lines.Add(asql.AsText);
             end;
         end
       else
         begin
           treeview2.Items.Clear;
           memo10.Lines.clear;
           memo10.Lines.add('Illegal: '+Root.astext);
           if assigned(asql) then
             begin
               memo9.Lines.Clear;
               memo9.Lines.Add(asql.AsText);
             end;
         end;
     end;

end;

function Tfrmdemo.GetCurrentParser: TGsqlparser;
var
  agsqlparser : TGsqlparser;
begin
  agsqlparser := nil;

  case TDbVendor(cbdbvendor.ItemIndex) of
    DBVOracle :
      agsqlparser := oracleparser;
    DBVMSSql :
      agsqlparser := mssqlparser;
    DBVMySql :
      agsqlparser := mysqlparser;
    DBVaccess :
      agsqlparser := msaccessparser;
    DBVDb2:
      agsqlparser := db2parser;
    else
      agsqlparser := genericparser;
  end;

  if not assigned(agsqlparser) then
    raise exception.Create('selected database is not supported in this version, check www.sqlparser.com for more info');

  result := agsqlparser;
end;

procedure Tfrmdemo.btnFetchDBObjectClick(Sender: TObject);
  function getdbobjectstr(pdbobjectlist:tlzdbobjectlist):lzstring;
  var
   i1: integer;
   lcstr1,lcstr2 : lzstring;
  begin
    lcstr2 := '';
    for i1:=0 to pdbobjectlist.Count - 1 do
      begin
         // get tables
         lcstr1 := pdbobjectlist[i1].ObjectFullName;
         lcstr2 := lcstr2+lcstr1;
         if i1 <> pdbobjectlist.Count - 1 then
          lcstr2 := lcstr2+#13#10;
      end;
    result := lcstr2;
  end;

var
  lcdbobject: tlzdbobject;
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr,prefixstr,tablesstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  lcse: TLzScriptExplorer;

begin

 agsqlparser := GetCurrentParser;
 mminspectedobjs.Lines.clear;

 agsqlparser.SqlText.assign(mmsqls.Lines);

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mminspectedobjs.Lines.clear;
     mminspectedobjs.Lines.add(agsqlparser.errormessages);
    end;

  if ret <> 0 then exit;

  lcse := TLzScriptExplorer.Create(nil);
  try
    lcse.sqlstatements := agsqlparser.SqlStatements;
    lcse.AnalyzeScript;
    lcse.FlattenDBList;
    mminspectedobjs.Lines.add(lcse.getObjectInfoInList);
  finally
    lcse.free;
  end;

end;

procedure Tfrmdemo.btntablehintClick(Sender: TObject);
var
  i :integer;
  lcdbobject : tlzdbobject;
  lctable : tlztable;
  agsqlparser : TGsqlparser;
begin
//  mmoutput.Lines.Clear;
//
//  agsqlparser := GetCurrentParser;
//
//  agsqlparser.SqlText.assign(mminput.Lines);
//
//  i:= agsqlparser.parse;
//
//  sqloutput.Lines.clear;
//  if agsqlparser.ErrorCount > 0 then
//    begin
//     mmoutput.Lines.add(agsqlparser.errormessages);
//    end;
//
//
////   for i:=0 to agsqlparser.TableList.Count - 1 do
//   for i:=0 to agsqlparser.dbobjectlist.Count - 1 do
//     begin
//       if agsqlparser.dbobjectlist[i].ObjectType <> ttObjTable then continue;
//       
//       lcdbobject :=  agsqlparser.dbobjectlist[i];
//       if assigned(lcdbobject.ObjectNode) then
//         begin
//           lcTable := lcdbobject.ObjectNode as TLzTable;
//
//           // ParentStmt is the statement where this table belonged to, maybe select,insert,update,delete, etc
//           if assigned(lcTable.ParentStmt) then
//             begin
//               if lcTable.ParentStmt is  TSelectSqlStatement then
//                 begin
//                   if TSelectSqlStatement(lcTable.ParentStmt).WithParenthesis
//                     + TSelectSqlStatement(lcTable.ParentStmt).WithParenthesisBeforeOrderby > 0 then
//                     showmessage('table in subquery:'+lctable.TableName);
//                 end;
//             end;
//
//           // uncomment next line to add with keyword to table hint
//           // lcTable.haswith := true;
//           if length(lcTable.mshintlist.AsText)>0 then //hint exists already , remove
//             lcTable.mshintlist.AsText := ' ' //set to a single space to remove hint, or any other hint to modify
//           else
//             lcTable.mshintlist.AsText := 'nolock';
//         end;
//     end;
//   mmoutput.Lines.add(agsqlparser.SqlStatements[0].asText);
//
end;

procedure Tfrmdemo.MyOnTableToken_replacetable(Sender: Tobject;
  pToken: TSourceToken; psqlstatement: TCustomSqlStatement);
begin
  if (Sender is TLzTable) then
    begin
      //table in this event is constructed as an TLzTable object, usually it's main point where this table occurs in statement
      if (pToken.DBObjType = ttobjtable) then
        begin
          if (Pos('"',pToken.AsText) = 1) then
            pToken.AsText := '"'+'view_'+copy(pToken.AsText,2,length(pToken.astext)-1)
          else if (Pos('[',pToken.AsText) = 1) then
            pToken.AsText := '['+'view_'+copy(pToken.AsText,2,length(pToken.astext)-1)
          else
            pToken.AsText := 'view_'+pToken.AsText;
        end
      else if (ptoken.DBObjType = ttobjtablealias) then
        begin
          // do nothing to table alias, add your own process here if necessary
        end;
    end
  else if (Sender is Tlz_Attr) then
    begin
      //table in this event is constructed as an TLz_Attr object, usually it's a reference to table
      if (pToken.DBObjType = ttobjtable) then
        begin
          if (Pos('"',pToken.AsText) = 1) then
            pToken.AsText := '"'+'view_'+copy(pToken.AsText,2,length(pToken.astext)-1)
          else if (Pos('[',pToken.AsText) = 1) then
            pToken.AsText := '['+'view_'+copy(pToken.AsText,2,length(pToken.astext)-1)
          else
            pToken.AsText := 'view_'+pToken.AsText;
        end
      else if (ptoken.DBObjType = ttobjtablealias) then
        begin
          // do nothing to table alias, add your own process here if necessary
        end;
    end
  else
    begin
      //should not go here!!!
    end;
    
end;

function Tfrmdemo.exprvisit(const pnode: tlz_node;
  pIsLeafNode: Boolean): boolean;
var
  lcstr: lzstring;
  lcexpr : tlzcustomexpression;
begin

  lcexpr := pnode as tlzcustomexpression;
  lcstr := OperatorStr[lcexpr.oper];
  if pIsLeafNode then
    begin
      Memo11.Lines.Add(pnode.AsText)
//      Memo11.Lines.Add(pnode.AsText+'('+lcstr+')')
    end
  else
    begin
      if assigned(lcexpr.opname) then
        lcstr := lcexpr.opname.AsText;
//        lcstr := lcexpr.opname.AsText+'('+lcstr+')';
      if lcexpr.oper = Expr_Parenthesis then
        lcstr := '( ) ';
//        lcstr := '( ) '+'('+lcstr+')';
      memo11.Lines.Add(lcstr);
    end;
  result := true;
end;

procedure Tfrmdemo.btnexprvisitClick(Sender: TObject);
var
  agsqlparser : TGsqlparser;
  ret : integer;
begin

  agsqlparser := GetCurrentParser;

  sqloutput.Lines.clear;
  memo11.Lines.Clear;
  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(memo9.Lines);

  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     sqloutput.Lines.clear;
     sqloutput.Lines.add(agsqlparser.errormessages);
    end;

  if ret <> 0 then exit;
  if agsqlparser.SqlStatements.Count = 0 then exit;
  asql :=  agsqlparser.SqlStatements[0];
  if not assigned(asql.WhereClause) then exit;

   case rgexprvisit.ItemIndex of
     0:
       agsqlparser.SqlStatements[0].WhereClause.PreOrderTraverse(exprvisit);
     1:
       agsqlparser.SqlStatements[0].WhereClause.InOrderTraverse(exprvisit);
     2:
       agsqlparser.SqlStatements[0].WhereClause.PostOrderTraverse(exprvisit);
   end;


end;

procedure Tfrmdemo.btnoracleClick(Sender: TObject);
var
  i,j,l,k,ret,sscount:integer;
  fromclause,lctn,whereclause,lctmpstr,lctmpstr2:String;
  lcstmt : TSelectSqlStatement;
  lcfmtopt : TLzFmtOpt;
  a: TStringlist;
  Counter: TJclCounter;
  EscapedTime : Real;
  isend : boolean;
  lctl : TLzTableList;
  lcts : TStringlist;
  lctable : TLzTable;
  lcexpr : TLzCustomExpression;
  lcparser : Tgsqlparser;


  function gettablenamefromexpr(pexpr : TLzCustomExpression):boolean;
  var
    lli : integer;
  begin
    result := false;
    pexpr.GetInvolvedDbObjects;
   // if pexpr.TableTokens.Count < 2 then exit;
    for lli:=0 to pexpr.TableTokens.Count - 1  do
      begin
        if lcts.IndexOf(pexpr.TableTokens[lli].astext) = -1 then
          lcts.Add(pexpr.TableTokens[lli].astext);
      end;
    result := lcts.Count = 2;
  end;

  function tablenameintablelist(ptablename :string):boolean;
    var
     i:Integer;
    begin
      result := false;
      for i:=0 to lctl.Count - 1 do
        begin
          if (AnsiCompareText(ptablename,lctl[i].TableName) = 0)
          or (AnsiCompareText(ptablename,lctl[i].TableAlias) = 0) then
            begin
              result := true;
              break;
            end;
        end;
    end;

  function findjointablenameinexpr(pexpr : TLzCustomExpression):string;
  var
    b1,b2 : Boolean;
  begin
    result := '';
    if pexpr.DummyTag <> 0 then exit;// this expression is processed already
    lcts.clear;
    if not gettablenamefromexpr(pexpr) then exit;
    b1 :=  tablenameintablelist(lcts[0]);
    b2 :=  tablenameintablelist(lcts[1]);
    if b1 and not b2 then
      result := lcts[1];
    if b2 and not b1 then
      result := lcts[0];
  end;

  function findjointablenameinexprs(pexprs : TObjectlist):string;
  var
    i:Integer;
    lct : string;
  begin
    lct := '';
    for i:=0 to pexprs.Count - 1 do
      begin
        lct := findjointablenameinexpr(TLzCustomExpression(pexprs[i]));
        if length(lct)>0 then break;
      end;
    result := lct;
  end;

  function checkexprbytablename(pt1 : string;pexpr : TLzCustomExpression):boolean;
  var
    i:Integer;
    b1,b2 : boolean;
  begin
    result := false;
    lcts.clear;
    if not gettablenamefromexpr(pexpr) then exit;
    b1 := AnsiCompareText(pt1,lcts[0]) = 0;
    b2 := AnsiCompareText(pt1,lcts[1]) = 0;
    if b1 then
      if tablenameintablelist(lcts[1]) then
        begin
          result := true;
          exit;
        end;

    if b2 then
      if tablenameintablelist(lcts[0]) then
        begin
          result := true;
          exit;
        end;
  end;

  function findexprbytablenameinexprs(pt1 : string;pexprs : TObjectlist):integer;
  var
    i,j:Integer;
  begin
    j := 0;
    for i:=0 to pexprs.Count - 1 do
      begin
        if  checkexprbytablename(pt1,TLzCustomExpression(pexprs[i])) then
          begin
            TLzCustomExpression(pexprs[i]).DummyTag := 2;
            inc(j);
          end;
      end;
    result := j;
  end;

  function FindTableByName(ptablename : string; ptlist : TLzTableList):TLzTable;
  var
    i:Integer;
  begin
      result := nil;
      for i:=0 to ptlist.Count - 1 do
        begin
          if (AnsiCompareText(ptablename,ptlist[i].TableName) = 0)
          or (AnsiCompareText(ptablename,ptlist[i].TableAlias) = 0) then
            begin
              lctl.Add(ptlist[i]);
              result := ptlist[i];
              break;
            end;
        end;
  end;

begin

  Memo14.Clear;
  lcparser := Tgsqlparser.Create(dbvoracle);
try
  lcparser.SqlText.assign(Memo12.Lines);

  ret := lcparser.parse;

  if lcparser.ErrorCount = 0 then
    begin
      for i:=0 to lcparser.SqlStatements.Count -1 do
        begin
          if lcparser.SqlStatements[i].SqlStatementType <> sstSelect then continue;
          if lcparser.SqlStatements[i].Tables.Count <=1 then continue;
          lcstmt := lcparser.SqlStatements[i] as TSelectSqlStatement;
          if not assigned(lcstmt.WhereClause) then //Cartesian product
            begin
              for j:=0 to lcstmt.Tables.Count - 1 do
                begin
                  if j = 0 then
                    fromclause := lcstmt.Tables[j].AsText
                  else
                    fromclause := fromclause+#13#10+'cross join '+lcstmt.Tables[j].AsText
                end;
              lcstmt.FromClauseText := fromclause;
            end
          else
            begin
              lctl := TLzTableList.Create(false);
              lcts := TStringlist.create;
              try
                lcstmt.WhereClause.flatten;

                for j:=0 to length(lcstmt.WhereClause.operlist) - 1 do
                  begin
                   if (lcstmt.WhereClause.operlist[j] <> Expr_and) then
                    raise exception.Create('Must be and conditon,it is:'+inttostr(integer(lcstmt.WhereClause.operlist[j])));
                  end;

                for j:=0 to lcstmt.WhereClause.flatexprs.Count - 1 do
                  TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).dummytag := 0;

                fromclause := lcstmt.Tables[0].AsText;
                lctl.Add(lcstmt.Tables[0]);

                for k:= 1 to lcstmt.Tables.Count - 1 do
                  begin
                    // find next join table name
                    lctn := findjointablenameinexprs(lcstmt.WhereClause.flatexprs);
                    if length(lctn)=0 then
                      raise exception.Create('Join table is not found('+lcstmt.Tables[k].AsText+')');
                    if findexprbytablenameinexprs(lctn,lcstmt.WhereClause.flatexprs) = 0 then
                      raise exception.Create('Join table is not found by tablename('+lctn+')');
                    lcTable := FindTableByName(lctn,lcstmt.tables);
                    if not assigned(lcTable) then
                      raise exception.Create('table('+lctn+') is not found in from clause');
                    lctmpstr := '';
                    lctmpstr2 := '';
                    lcexpr := nil;
                    l := 0;
                    for j:=0 to lcstmt.WhereClause.flatexprs.Count - 1 do
                      begin
                        if TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).dummytag = 2 then
                          begin
                            lcexpr := TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]);
                            if l>0 then
                              lctmpstr := lctmpstr+' and ';

                            if not assigned(lcexpr) then
                              raise exception('condition is not found for table('+lctn+')');

                            if assigned(lcexpr.lexpr) then
                              begin
                                if  TLzCustomExpression(lcexpr.lexpr).oper = Expr_OuterJoin then
                                  begin
                                   TLzCustomExpression(lcexpr.lexpr).opname.AsText := ''; //remove (+)
                                   lcts.Clear;
                                   gettablenamefromexpr(TLzCustomExpression(lcexpr.lexpr));
                                   if lcts.Count = 1 then
                                     begin
                                       if (AnsiCompareText(lcts[0],lctable.TableName) = 0)
                                       or (AnsiCompareText(lcts[0],lctable.TableAlias) = 0) then
                                         begin
                                           lctmpstr2 := 'left ';
                                         end
                                       else
                                         lctmpstr2 := 'right ';
                                     end;
                                  end
                              end;

                            if assigned(lcexpr.rexpr) then
                              begin
                                if  TLzCustomExpression(lcexpr.rexpr).oper = Expr_OuterJoin then
                                  begin
                                   TLzCustomExpression(lcexpr.rexpr).opname.AsText := ''; //remove (+)
                                   lcts.Clear;
                                   gettablenamefromexpr(TLzCustomExpression(lcexpr.rexpr));
                                   if lcts.Count = 1 then
                                     begin
                                       if (AnsiCompareText(lcts[0],lctable.TableName) = 0)
                                       or (AnsiCompareText(lcts[0],lctable.TableAlias) = 0) then
                                         begin
                                           lctmpstr2 := 'left ';
                                         end
                                       else
                                         lctmpstr2 := 'right ';
                                     end;
                                  end
                              end;

                            lctmpstr := lctmpstr+' '+TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).astext;
                            TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).dummytag := 1;
                            inc(l);
                          end;
                      end;


                    fromclause := fromclause+#13#10+lctmpstr2+'join '+lcTable.AsText+' on '+lctmpstr;
                   end;

                lcstmt.FromClauseText := fromclause;
                whereclause := '';
                for j:=0 to lcstmt.WhereClause.flatexprs.Count - 1 do
                  begin
                    if TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).dummytag = 0 then
                      begin
                        if length(whereclause) = 0 then
                         whereclause := TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).astext
                        else
                         whereclause := whereclause+' and '+TLzCustomExpression(lcstmt.WhereClause.flatexprs[j]).astext;
                      end;
                  end;
                if length(whereclause) > 0 then
                  lcstmt.WhereClausetext := whereclause
                else
                  lcstmt.WhereClausetext := ' ';

              finally
                lctl.free;
                lcts.free;
              end;
            end;
        end;

      for i:=0 to lcparser.SqlStatements.Count -1 do
        begin
          Memo14.Lines.Add(lcparser.SqlStatements[i].AsText);
          Memo14.Lines.Add('');
        end;
    end;

  if lcparser.ErrorCount > 0 then
    Memo14.lines.add('syntax error:'+lcparser.ErrorMessages);
  if ret < 0 then
    Memo14.lines.add('Fatal error in input');
finally
  lcparser.free;
end;


end;

procedure Tfrmdemo.btnmssqlserverClick(Sender: TObject);
type
  Tjoinrec = record
    mastertable : lzstring;
    jointable : lzstring;
    jointype : integer; //1:left outer join, 2: right outer join
    condition : lzstring;
    used : boolean;
  end;
var
  i,j,l,m,k,ret:integer;
  fromclause,lctmpstr :lzstring;
  lcstmt : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
  doconvert : boolean;
  lctable : TLzTable;
  lcexpr,pcExpr1,pcExpr2,pcExpr3 : TLzCustomExpression;
  lcjoinreclist : array[1..100] of  Tjoinrec;
  lcjoinrecnum : integer;

  function gettablename(anode : tlz_node):lzstring;
  begin
    result := '';
    if anode.Nodetype <> T_Expr then exit;
    if assigned(TLzCustomExpression(anode).lexpr) then
     result := tlz_attr(TLzCustomExpression(anode).lexpr).Prefix;
  end;

  function isthisatablename(atablename : lzstring; atable : tlztable):boolean;
  begin
     result := (AnsiCompareText(atablename,atable.TableName) = 0)
          or (AnsiCompareText(atablename,atable.TableAlias) = 0) ;
  end;

  function FindTableInTablelist(ptablename : lzstring; ptlist : TLzTableList; endpos : integer):boolean;
  var
    i:Integer;
  begin
      result := false;
      for i:=0 to ptlist.Count - 1 do
        begin
          if i = endpos then break;
          if (AnsiCompareText(ptablename,ptlist[i].TableName) = 0)
          or (AnsiCompareText(ptablename,ptlist[i].TableAlias) = 0) then
            begin
              result := true;
              break;
            end;
        end;
  end;

begin

  agsqlparser := TGsqlparser.Create(dbvmssql);

try
  Memo14.lines.clear;
  agsqlparser.SqlText.assign(Memo13.Lines);


  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount = 0 then
    begin
      for i:=0 to agsqlparser.SqlStatements.Count -1 do
        begin
          if agsqlparser.SqlStatements[i].SqlStatementType <> sstSelect then continue;
          if agsqlparser.SqlStatements[i].Tables.Count <=1 then continue;
          lcstmt := agsqlparser.SqlStatements[i] as TSelectSqlStatement;

          if not assigned(lcstmt.WhereClause) then //Cartesian product
            begin
              for j:=0 to lcstmt.Tables.Count - 1 do
                begin
                  if j = 0 then
                    fromclause := lcstmt.Tables[j].AsText
                  else
                    fromclause := fromclause+#13#10+'cross join '+lcstmt.Tables[j].AsText
                end;
              lcstmt.FromClauseText := fromclause;
            end
          else
            begin //other join type
                doconvert := true;
                lcjoinrecnum := 0;
                pcExpr1 := lcstmt.WhereClause;

                if pcExpr1.oper = Expr_Leftjoin then
                  begin
                    inc(lcjoinrecnum);
                    lcjoinreclist[lcjoinrecnum].mastertable := gettablename(pcExpr1.lexpr);
                    lcjoinreclist[lcjoinrecnum].jointable := gettablename(pcExpr1.rexpr);
                    lcjoinreclist[lcjoinrecnum].jointype := 1;// 'left outer join';
                    lcjoinreclist[lcjoinrecnum].condition := pcExpr1.lexpr.AsText+' = '+pcexpr1.rexpr.AsText;
                    lcjoinreclist[lcjoinrecnum].used := false;
                    pcExpr1.astext := ' ';//remove this expression from where clause
                  end
                else if pcExpr1.oper = Expr_rightjoin then
                  begin
                    inc(lcjoinrecnum);
                    lcjoinreclist[lcjoinrecnum].mastertable := gettablename(pcExpr1.lexpr);
                    lcjoinreclist[lcjoinrecnum].jointable := gettablename(pcExpr1.rexpr);
                    lcjoinreclist[lcjoinrecnum].jointype := 2; //'right outer join';
                    lcjoinreclist[lcjoinrecnum].condition := pcExpr1.lexpr.AsText+' = '+pcexpr1.rexpr.AsText;
                    lcjoinreclist[lcjoinrecnum].used := false;
                    pcExpr1.astext := ' ';//remove this expression from where clause
                  end
                else
                  begin // multilevel in expression

                      // flatten expression in where clause
                      pcExpr1.FlattenExpr;

                      // check is =* or *= in this expression
                      for j:=0 to pcExpr1.ChildNodes.Count-1 do
                        begin
                          if (pcExpr1.ChildNodes[j] as TLz_node ).Nodetype = T_Expr then
                            begin

                              pcExpr2 := pcExpr1.ChildNodes[j] as TLzCustomExpression;
                              if (j <> pcExpr1.ChildNodes.Count-1) and (pcExpr2.ExprTag <> Expr_and) then
                                begin // all sub expr must be linked with and
                                  doconvert := false;
                                  break;
                                end;

                              // analyze expression
                              if pcExpr2.oper = Expr_Leftjoin then
                                begin
                                  inc(lcjoinrecnum);
                                  lcjoinreclist[lcjoinrecnum].mastertable := gettablename(pcExpr2.lexpr);
                                  lcjoinreclist[lcjoinrecnum].jointable := gettablename(pcExpr2.rexpr);
                                  lcjoinreclist[lcjoinrecnum].jointype := 1; //'left outer join';
                                  lcjoinreclist[lcjoinrecnum].condition := pcExpr2.lexpr.AsText+' = '+pcExpr2.rexpr.AsText;
                                  lcjoinreclist[lcjoinrecnum].used := false;
                                  pcExpr2.astext := ' ';//remove this expression from where clause
                                  continue;
                                end;
                              if pcExpr2.oper = Expr_rightjoin then
                                begin
                                  inc(lcjoinrecnum);
                                  lcjoinreclist[lcjoinrecnum].mastertable := gettablename(pcExpr2.lexpr);
                                  lcjoinreclist[lcjoinrecnum].jointable := gettablename(pcExpr2.rexpr);
                                  lcjoinreclist[lcjoinrecnum].jointype := 2; //'right outer join';
                                  lcjoinreclist[lcjoinrecnum].condition := pcExpr2.lexpr.AsText+' = '+pcExpr2.rexpr.AsText;
                                  lcjoinreclist[lcjoinrecnum].used := false;
                                  pcExpr2.astext := ' ';//remove this expression from where clause
                                  continue;
                                end;
                            end
                          else  // other node in expression, don't convert
                            begin
                              doconvert := false;
                              break;
                            end;
                        end; // for j:=0 to pcExpr1.ChildNodes.Count-1 do
                  end;//  multilevel in expression

                 if lcjoinrecnum = 0 then doconvert := false;
                 if lcjoinrecnum <  lcstmt.Tables.Count - 1 then
                   begin
                     doconvert := false;
                     showmessage('not enough join conditions');
                   end;


                // construct the whole join clause according to previous list
                 if doconvert then
                   begin
                     fromclause := lcstmt.Tables[0].AsText;
                     for k:= 1 to lcstmt.Tables.Count - 1 do
                       begin
                         lctable := lcstmt.Tables[k];
                         lctmpstr := '';
                         //check join record info for each table
                         for l := 1 to lcjoinrecnum do
                           begin
                             if lcjoinreclist[l].used then continue;
                             if isthisatablename(lcjoinreclist[l].jointable,lctable) then
                               begin
                                 if FindTableInTablelist(lcjoinreclist[l].mastertable,lcstmt.Tables,k) then
                                   begin
                                      // from t1,t2 where t1.f1 *= t2.f1
                                      lcjoinreclist[l].used := true;
                                      if lcjoinreclist[l].jointype = 1 then
                                        lctmpstr := 'left outer join '+lctable.AsText+' '+lcjoinreclist[l].condition;
                                      if lcjoinreclist[l].jointype = 2 then
                                        lctmpstr := 'right outer join '+lctable.AsText+' '+lcjoinreclist[l].condition;
                                      for m:= l+1 to lcjoinrecnum do
                                        begin
                                          // from t1,t2 where t1.f1 *= t2.f1  and t1.f2 *= t2.f2
                                          if lcjoinreclist[m].used then break;
                                          if (lcjoinreclist[m].mastertable = lcjoinreclist[l].mastertable)
                                            and (lcjoinreclist[m].jointable = lcjoinreclist[l].jointable)
                                            and (lcjoinreclist[m].jointype = lcjoinreclist[l].jointype)
                                          then
                                            begin
                                              lctmpstr := lctmpstr+' and '+ lcjoinreclist[m].condition;
                                              lcjoinreclist[m].used := true;
                                            end;
                                        end;
                                   end
                                 else
                                   begin
                                     // from t1,t2,t3 where  ... and t3.f1 *= t2.f1 and ...
                                   end;
                               end
                             else if isthisatablename(lcjoinreclist[l].mastertable,lctable) then
                               begin
                                 if FindTableInTablelist(lcjoinreclist[l].jointable,lcstmt.Tables,k) then
                                   begin
                                     // from t1,t2  where  t2.f1 *= t1.f1
                                      lcjoinreclist[l].used := true;
                                      if lcjoinreclist[l].jointype = 1 then  // CAUTION HERE
                                        lctmpstr := 'right outer join '+lctable.AsText+' '+lcjoinreclist[l].condition;
                                      if lcjoinreclist[l].jointype = 2 then  // CAUTION HERE
                                        lctmpstr := 'left outer join '+lctable.AsText+' '+lcjoinreclist[l].condition;
                                      for m:= l+1 to lcjoinrecnum do
                                        begin
                                          // from t1,t2 where t2.f1 *= t1.f1  and t2.f2 *= t1.f2
                                          if lcjoinreclist[m].used then break;
                                          if (lcjoinreclist[m].mastertable = lcjoinreclist[l].mastertable)
                                            and (lcjoinreclist[m].jointable = lcjoinreclist[l].jointable)
                                            and (lcjoinreclist[m].jointype = lcjoinreclist[l].jointype)
                                          then
                                            begin
                                              lctmpstr := lctmpstr+' and '+ lcjoinreclist[m].condition;
                                              lcjoinreclist[m].used := true;
                                            end;
                                        end;
                                   end
                                 else
                                   begin
                                   end;
                               end;
                           end;
                         fromclause := fromclause+#13#10+lctmpstr;
                       end;
                   end; //doconvert
              lcstmt.FromClauseText := fromclause;
            end; // other join type
        end; // for

      for i:=0 to agsqlparser.SqlStatements.Count -1 do
        begin
          Memo14.Lines.Add(agsqlparser.SqlStatements[i].AsText);
        end;
    end;

  if agsqlparser.ErrorCount > 0 then
    Memo14.lines.add('error token in input:'+agsqlparser.ErrorMessages);
  if ret < 0 then
    Memo14.lines.add('Fatal error in input');

finally
  agsqlparser.Free;
end;


end;

procedure Tfrmdemo.btnremovevarinwhereClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  agsqlparser : TGsqlparser;
  lcstrlist : TStringlist;
  lcv : TLzWhereClauseVisitor;//TLzModifyVarVisitor;
begin

  agsqlparser := TGsqlparser.Create(dbvmssql);
  agsqlparser.SqlText.Assign(memo15.Lines);

  ret := agsqlparser.parse;

  Memo4.lines.clear;
  if agsqlparser.ErrorCount > 0 then
    begin
     Memo4.Lines.add(agsqlparser.errormessages);
    end;

//    agsqlparser.SqlStatements[0].GetFieldsFromExpr(agsqlparser.SqlStatements[0].WhereClause,lcstrlist);
  if agsqlparser.SqlStatements.Count>0 then
  begin
     lcv := TLzWhereClauseVisitor.create;//TLzModifyVarVisitor.Create;
     try
       lcv.ParseTree := agsqlparser.SqlStatements[0];//.WhereClause;
       lcv.vars := edvars.Text;
       lcv.Convert;
     finally
       lcv.Free;
     end;
     Memo4.Lines.add(agsqlparser.SqlStatements[0].asText);
  end;


end;

procedure Tfrmdemo.btnremovefieldinwhereclauseClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  agsqlparser : TGsqlparser;
  lcstrlist : TStringlist;
  lcv : TLzRemoveTokenVisitor;
begin

  agsqlparser := TGsqlparser.Create(dbvmssql);
  agsqlparser.SqlText.Assign(Memo15.Lines);

  ret := agsqlparser.parse;

  Memo4.Lines.clear;
  if agsqlparser.ErrorCount > 0 then
    begin
     Memo4.Lines.add(agsqlparser.errormessages);
    end;

  if agsqlparser.SqlStatements.Count>0 then
  begin
    if assigned(agsqlparser.SqlStatements[0].WhereClause) then
      begin
           lcv := TLzRemoveTokenVisitor.Create;
           try
             lcv.ParseTree := agsqlparser.SqlStatements[0].WhereClause;
             lcv.strs := edfields.text;
             lcv.Convert;
           finally
             lcv.Free;
           end;
      end;

     Memo4.Lines.add(agsqlparser.SqlStatements[0].asText);
  end;


end;

function TLzRemoveTokenVisitor.AcceptVisitor: boolean;
begin
  result :=  FVisited is TSourceToken;
end;


function TLzRemoveTokenVisitor.DoConvert: integer;
begin
  parsetree.Iterate(self);
  result := 0;
end;


constructor TLzRemoveTokenVisitor.Create;
begin
  inherited;
  ParseTree := nil;
  FInfoStack := TObjectlist.create(false);
  Fvars := TLzStringlist.Create;
  attr := nil;
end;

destructor TLzRemoveTokenVisitor.Destroy;
begin
  FInfoStack.free;
  Fvars.free;
  inherited;
end;


function TLzRemoveTokenVisitor.Convert: integer;
var
  i,len:Integer;
  s : lzString;
begin
  if not assigned(ParseTree) then exit;
  if not (ParseTree is TLzCustomExpression) then exit;
  expr1 := ParseTree as TLzCustomExpression;
  expr1.NodeDummyTag := 1; // root expr
  FInfoStack.add(expr1);
  len := length(strs);
  s := '';
  for i:= 1 to len do
    begin
      if strs[i] <> ',' then
        s := s+strs[i]
      else
        begin
          fvars.Add(s);
          s := '';
        end;
    end;
  if length(s)>0 then //last one
    fvars.Add(s);

  result := DoConvert;

end;

procedure TLzRemoveTokenVisitor.Execute(const pVisited: TLzVisitedAbs);
var
  i,j:integer;
  at,lcToken : TSourceToken;
  SourceTokens : TSourceTokenList;
  lcexpr : TlzCustomExpression;
  isfound : Boolean;
  removestr : lzstring;
begin
  inherited Execute(pVisited);
  if not AcceptVisitor then exit;

  at := pVisited as TSourceToken;
  if assigned(attr) then
    removestr := trim(attr.AsText)
  else
    removestr := at.sourcecode;

  if  (fvars.IndexOf(removestr) <> -1)  then
//  if  (fvars.IndexOf(at.sourcecode) <> -1)  then
    begin
      if finfostack.Count = 0 then //the input expr have no and/or subexpr
        parsetree.AsText := '  '
      else
        begin
          isfound := false;
          for i:= finfostack.Count -1 downto 0 do
            begin
              lcexpr := finfostack[i] as TlzCustomExpression;
              if lcexpr.oper in [expr_and,expr_or] then
                begin
                  if lcexpr.lexpr.NodeDummyTag = 1 then
                    lcexpr.lexpr.AsText := '  '; //multi spaces, make it different with single space
                  if lcexpr.rexpr.NodeDummyTag = 1 then
                    lcexpr.rexpr.AsText := '  ';
                  lcexpr.opname.SourceCode := '';
                  isfound :=true;
                  if i > 0 then //check is and/or in between
                    begin
                      lcexpr := finfostack[i-1] as TlzCustomExpression;
                      if lcexpr.oper in [expr_between] then
                        lcexpr.AsText := '  ';
                    end;
                  break;
                end;
            end; //for

          if not isfound then //var in top level
            parsetree.AsText := '  ';
        end; //else
    end;
end;

procedure TLzRemoveTokenVisitor.PreExecute(const pVisited: TLzVisitedAbs);
var
  lcexpr : TLzCustomExpression;
begin
  if pVisited is TLzCustomExpression then
    begin
     lcexpr := pVisited as TLzCustomExpression;
     lcexpr.NodeDummyTag := 1;// means in stack
     FInfoStack.add(lcexpr);
    end;

  if pVisited is TLz_attr then
    attr := pVisited as TLz_attr;

end;


procedure TLzRemoveTokenVisitor.PostExecute(const pVisited: TLzVisitedAbs);
var
  lcexpr,lcexpr2,lcexpr3 : TLzCustomExpression;
begin

  if pVisited is TLz_attr then
    attr := nil;

  if (finfoStack.count>0) and (pVisited is TLzCustomExpression) then
    begin
      lcexpr := finfoStack[finfoStack.count -1 ] as TLzCustomExpression;
      if (length(trim(lcexpr.AsText)) = 0)  and (finfoStack.count > 1) then
        begin
          lcexpr2 := finfoStack[finfoStack.count -2 ] as TLzCustomExpression;
          if lcexpr2.oper in [expr_parenthesis] then
            lcexpr2.AsText := '  ';

          if lcexpr2.oper in [expr_and,expr_or] then
            begin
              if lcexpr2.lexpr.NodeDummyTag = 1 then
                lcexpr2.lexpr.AsText := '  '; //multi spaces, make it different with single space
              if lcexpr2.rexpr.NodeDummyTag = 1 then
                lcexpr2.rexpr.AsText := '  ';
              lcexpr2.opname.SourceCode := '';

              if finfoStack.count > 2 then
                begin
                  lcexpr3 := finfoStack[finfoStack.count - 3 ] as TLzCustomExpression;
                  if lcexpr3.oper in [expr_between] then
                    lcexpr3.AsText := '  ';
                end;
            end;

        end;


     // if lcexpr.oper in [expr_between] then
     //   lcexpr.AsText := '  ';

      TLzCustomExpression(finfoStack[finfoStack.count -1 ]).NodeDummyTag := 0;
      finfoStack.Extract(finfoStack[finfoStack.count -1 ]);
    end;
end;

{ TLzCheckFieldVisitor }

function TLzCheckFieldVisitor.AcceptVisitor: boolean;
begin
  result :=  (FVisited is TSourceToken ) and ContinueVisiting;
end;

function TLzCheckFieldVisitor.Convert: Boolean;
var
  i,len:Integer;
  s : lzString;
begin
  if not assigned(ParseTree) then exit;
  if not (ParseTree is TLzCustomExpression) then exit;

  len := length(strs);
  s := '';
  for i:= 1 to len do
    begin
      if strs[i] <> ',' then
        s := s+strs[i]
      else
        begin
          fvars.Add(s);
          s := '';
        end;
    end;
  if length(s)>0 then //last one
    fvars.Add(s);

  parsetree.Iterate(self);
  result := isFieldIn;

end;

constructor TLzCheckFieldVisitor.Create;
begin
  inherited;
  ParseTree := nil;
  Fvars := TLzStringlist.Create;
  IsFieldIn := false;
  attr := nil;
end;

destructor TLzCheckFieldVisitor.Destroy;
begin
  Fvars.free;
  inherited;
end;

procedure TLzCheckFieldVisitor.Execute(const pVisited: TLzVisitedAbs);
var
  at : TSourceToken;
  removestr : lzstring;
begin
  inherited Execute(pVisited);
  if not AcceptVisitor then exit;

  at := pVisited as TSourceToken;
  if assigned(attr) then
    removestr := trim(attr.AsText)
  else
    removestr := at.sourcecode;

  if  (fvars.IndexOf(removestr) <> -1)  then

//  if  (fvars.IndexOf(at.SourceCode) <> -1)  then
    begin
      IsFieldIn := true;
      ContinueVisiting := false;
    end;

end;

procedure TLzCheckFieldVisitor.PostExecute(const pVisited: TLzVisitedAbs);
begin
  inherited;
  if pVisited is TLz_attr then
    attr := nil;

end;

procedure TLzCheckFieldVisitor.PreExecute(const pVisited: TLzVisitedAbs);
begin
  inherited;
  if pVisited is TLz_attr then
    attr := pVisited as TLz_attr;

end;

procedure Tfrmdemo.btnisfieldinexprClick(Sender: TObject);
var
  i,j,ret,sscount:integer;
  agsqlparser : TGsqlparser;
  lcstrlist : TStringlist;
  lcv : TLzCheckFieldVisitor;
begin

  agsqlparser := TGsqlparser.Create(dbvmssql);
  agsqlparser.SqlText.Assign(Memo15.Lines);

  ret := agsqlparser.parse;

  Memo4.Lines.clear;
  if agsqlparser.ErrorCount > 0 then
    begin
     Memo4.Lines.add(agsqlparser.errormessages);
    end;

  if agsqlparser.SqlStatements.Count>0 then
  begin
    if assigned(agsqlparser.SqlStatements[0].WhereClause) then
      begin
           lcv := TLzCheckFieldVisitor.Create;
           try
             lcv.ParseTree := agsqlparser.SqlStatements[0].WhereClause;
             lcv.strs := edfields.text;
             if lcv.Convert then
               Memo4.Lines.add('Found')
             else
               Memo4.Lines.add('Not Found');
           finally
             lcv.Free;
           end;
      end;


  end;


end;

procedure Tfrmdemo.DBObject2TreeView(pServerList: TLzDBObjectList;
  TV: TTreeview);
  procedure addtokentonode(pTokens : tsourcetokenlist; pNode : TTreeNode);
  var
    j:integer;
    newNode:TTreeNode;
  begin
    for j := 0 to pTokens.Count - 1 do
    begin
      newNode := TV.Items.AddChild(
        pNode,pTokens[j].astext
        +'('
        + inttostr(pTokens[j].XPosition)
        +','
        + inttostr(pTokens[j].YPosition)
        +')');
      newNode.Data := pTokens[j];
    end;    // for
  end;

  procedure ReadDBObject(Root:TTreeNode; pdbList : TLzDBObjectList; ptype : TDBObjType);
  var
    j,i:integer;
    newNode,newNode2,newNode3:TTreeNode;
  begin
    for i:=0 to pdblist.Count-1 do
    begin
      if pdbList[i].ObjectType <> ptype then continue;

      newNode:=TV.Items.AddChild( Root,pdblist[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pdblist[i].TokensInScript.Count)+')' );
      addtokentonode(pdbList[i].TokensInScript,newNode2);
      ReadDBObject(newNode, pdblist[i].ChildDBObjects,ptype);
    end;
  end;

  procedure ReadField(Root : TTreeNode; pFieldList : TLzDBObjectList);
  var
    i,j:integer;
    newNode,newnode2,newnode3:TTreeNode;
  begin
    for i:=0 to pFieldList.Count-1 do
    begin
      if pFieldList[i].ObjectType <> ttobjField  then continue;

      newNode:=TV.Items.AddChild( Root,pFieldList[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pFieldList[i].TokensInScript.Count)+')' );
      addtokentonode(pFieldList[i].TokensInScript,newNode2);
    end;
  end;

  procedure ReadTable(Root : TTreeNode; pTableList : TLzDBObjectList);
  var
    i,j,fields:integer;
    newNode,newnode2,newnode3,fieldnode:TTreeNode;
  begin
    for i:=0 to pTableList.Count-1 do
    begin
      if pTableList[i].ObjectType <> ttobjTable  then continue;

      newNode:=TV.Items.AddChild( Root,pTableList[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pTableList[i].TokensInScript.Count)+')' );

      addtokentonode(pTableList[i].TokensInScript,newNode2);


      //count fields number in table
      fields := 0;
      for j:=0 to pTableList[i].ChildDBObjects.Count-1 do
        begin
          case pTableList[i].ChildDBObjects[j].ObjectType of
           ttobjField:
            inc(fields);
           end;
        end;
      fieldnode:=TV.Items.AddChild( newNode,'Fields('+inttostr(fields)+')' );
      ReadField(fieldnode, pTableList[i].ChildDBObjects);

    end;
  end;

  procedure ReadSchema(Root : TTreeNode; pSchemaList : TLzDBObjectList);
  var
    i,j,tables,functions,views,indexes,sequences,packages,triggers:integer;
    newNode,newNode2,newNode3, objnode:TTreeNode;
  begin
    for i:=0 to pSchemaList.Count-1 do
    begin
      newNode:=TV.Items.AddChild( Root,pSchemaList[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pSchemaList[i].TokensInScript.Count)+')' );
      addtokentonode(pSchemaList[i].TokensInScript,newNode2);

      //count different objects number in schema
      tables := 0;
      for j:=0 to pSchemaList[i].ChildDBObjects.Count-1 do
        begin
          case pSchemaList[i].ChildDBObjects[j].ObjectType of
           ttobjTable:inc(tables);
           ttobjFunction: inc(functions);
           ttobjView: inc(views);
           ttobjIndex: inc(indexes);
           ttobjTrigger: inc(triggers);
           ttobjsequence: inc(sequences);
           ttobjPackage: inc(packages);
           end;
        end;

      if tables > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'Tables('+inttostr(tables)+')' );
          ReadTable(objnode, pSchemaList[i].ChildDBObjects);
        end;

      if functions > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'functions('+inttostr(functions)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjfunction);
        end;

      if views > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'views('+inttostr(views)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjview);
        end;

      if indexes > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'indexes('+inttostr(indexes)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjindex);
        end;

      if triggers > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'triggers('+inttostr(triggers)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjtrigger);
        end;

      if sequences > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'sequences('+inttostr(sequences)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjsequence);
        end;

      if packages > 0 then
        begin
          objnode:=TV.Items.AddChild( newNode,'packages('+inttostr(packages)+')' );
          ReadDBObject(objnode, pSchemaList[i].ChildDBObjects,ttobjpackage);
        end;

      // ReadDBObject(tablenode, pSchemaList[i].ChildDBObjects);

    end;
  end;

  procedure ReadDB(Root : TTreeNode; pDBList : TLzDBObjectList);
  var
    i,j,schemas:integer;
    newNode,newNode2,newNode3:TTreeNode;
  begin
    for i:=0 to pDBList.Count-1 do
    begin
      newNode:=TV.Items.AddChild( Root,pDBList[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pDBList[i].TokensInScript.Count)+')' );
      addtokentonode(pDBList[i].TokensInScript,newNode2);


      //count schema number in database
      schemas := 0;
      for j:=0 to pDBList[i].ChildDBObjects.Count-1 do
        begin
          if pDBList[i].ChildDBObjects[j].ObjectType = ttobjschema then
            inc(schemas);
        end;

      newNode2:=TV.Items.AddChild( newNode,'Schema('+inttostr(schemas)+')' );

      ReadSchema(newNode2, pDBList[i].ChildDBObjects);
    end;
  end;

  procedure ReadServer(Root : TTreeNode; pServerList : TLzDBObjectList);
  var
    i,dbs,j:integer;
    newNode,newNode2,newNode3:TTreeNode;
  begin

    for i:=0 to pServerList.Count-1 do
    begin
      newNode:=TV.Items.AddChild( Root,pServerList[i].ObjectName );

      newNode2 :=TV.Items.AddChild( newNode,'Tokens in script('+inttostr(pServerList[i].TokensInScript.Count)+')' );
      addtokentonode(pServerList[i].TokensInScript,newNode2);


      //count db number in server
      dbs := 0;
      for j:=0 to pServerList[i].ChildDBObjects.Count-1 do
        begin
          if pServerList[i].ChildDBObjects[j].ObjectType = ttobjDatabase then
            inc(dbs);
        end;

      newNode2:=TV.Items.AddChild( newNode,'Database('+inttostr(dbs)+')' );
      ReadDB(newNode2, pServerList[i].ChildDBObjects);
    end;
  end;

begin
  ReadServer(TV.Items.AddChild( nil,'Servers('+inttostr(pServerList.Count)+')'), pServerList);
end;


procedure Tfrmdemo.btndbexplorerClick(Sender: TObject);
var
  lcse: TLzScriptExplorer;
  i,j,ret,sscount:integer;
  s,ssstr,s1,s2,lcstr:lzstring;
  asel : TSelectSqlStatement;
  agsqlparser : TGsqlparser;
 // xmlvs: TLzParseTree2XMLVisitor;
  textvs : TLzGetTextVisitor;
  XML: TXMLDocument;
begin

  mmdbexplorer.Lines.clear;
  TreeViewdbexplorer.Items.clear;
  
  agsqlparser := GetCurrentParser;

  agsqlparser.Sqlfilename := '';
  agsqlparser.SqlText.assign(redbexplorer.Lines);


  ret := agsqlparser.parse;

  if agsqlparser.ErrorCount > 0 then
    begin
     mmdbexplorer.Lines.add(agsqlparser.errormessages);
    end;

  if ret <> 0 then exit;

  lcse :=  TLzScriptExplorer.Create(nil);
  try
    lcse.sqlstatements := agsqlparser.SqlStatements;
    i := lcse.AnalyzeScript;
    DBObject2TreeView(lcse.TopLevelDBObjectList,TreeViewdbexplorer);
    treeviewdbexplorer.FullExpand;
  finally
    lcse.Free;
  end;

end;

procedure Tfrmdemo.treeviewdbexplorerClick(Sender: TObject);
var
  I: Integer;
  foundat: longint;
  toend: Integer;
  startpos: Integer;
  lcst: tsourcetoken;
begin
  if treeviewdbexplorer.Selected = nil then Exit;
  lcst := treeviewdbexplorer.selected.data;
  if assigned(lcst) then
    begin
     with redbexplorer do
     begin
       startpos := 0;
       for I := 0 to lcst.XPosition - 2 do    // Iterate
       begin
         startpos := startpos + length(lines[i]);
       end;    // for
       startpos := startpos + (lcst.YPosition-length(lcst.astext)) - 1;
       toend := length(text) - startpos;
       foundat := findtext(lcst.AsText,startpos,toend,[stMatchCase]);
      if FoundAt <> -1 then
      begin
        SetFocus;
        SelStart := FoundAt;
        SelLength := Length(lcst.astext);
      end;
     end;    // with
    end;
end;

procedure Tfrmdemo.tsdbexplorerShow(Sender: TObject);
begin
  treeviewdbexplorer.Items.clear;
end;

procedure Tfrmdemo.btnonlinexmldemoClick(Sender: TObject);
begin
  ShellExecute( 0, 'open', PChar( 'http://www.sqlparser.com/docs_sqlxml.php' ), nil, nil, SW_NORMAL );
end;

procedure Tfrmdemo.pp(isPlainText: boolean);
var
  ret : integer;
  agsqlparser : TGsqlparser;
  Counter: TJclCounter;
  EscapedTime : Real;
  lccvt : tlzlangconverter;
  lcstrstream : tstringstream;
begin

  agsqlparser := GetCurrentParser;

  // Please check help document for more format options
  gFmtOpt.case_keywords :=  TCaseOption(rg_caseoption.ItemIndex);
  gfmtopt.case_funcname :=  TCaseOption(rg_caseoption.ItemIndex);
  gfmtopt.case_Identifier :=  TCaseOption(rgidentcase.ItemIndex);

  gFmtOpt.Select_keywords_alignoption :=TAlignOption(rg_keywordalign.itemindex);
  gFmtOpt.Select_Columnlist_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.insert_keywords_alignoption := TAlignOption(rg_keywordalign.itemindex);
  gFmtOpt.insert_Columnlist_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.insert_valuelist_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.Select_fromclause_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.Select_Orderby_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.Select_Groupby_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.LinefeedsComma_option := TLinefeedsCommaOption(rg_lf_comma.ItemIndex);
  gFmtOpt.delete_keywords_alignOption :=TAlignOption(rg_keywordalign.itemindex);
  gFmtOpt.update_keywords_alignOption :=TAlignOption(rg_keywordalign.itemindex);
  gFmtOpt.update_Columnlist_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtOpt.expression_align_Style  := TAlignStyle(rg_listoption.ItemIndex);
  gFmtopt.VarAlign_option := TAlignOption(rg_keywordalign.itemindex);
  gFmtopt.Parameters_Style := TAlignStyle(rg_listoption.ItemIndex);
  gFmtopt.Parameters_align_option :=  TAlignOption(rg_keywordalign.itemindex);
  gFmtopt.Createtable_Fieldlist_Style   := TAlignStyle(rg_listoption.ItemIndex);
//  gFmtopt.Createtable_Fieldlist_Style_option  :=  TAlignOption(rg_keywordalign.itemindex);
//  gFmtopt.Parameters_LinefeedsComma_option := TLinefeedsCommaOption(rg_lf_comma.ItemIndex);
  gFmtopt.Createtable_Fieldlist_Comma_option := TLinefeedsCommaOption(rg_lf_comma.ItemIndex);

  gFmtOpt.LinefeedsAndOr_option := TLinefeedsAndOrOption(rg_lf_andor.ItemIndex);

  gfmtopt.SelectItemInNewLine := cbselectiteminnewline.Checked;
  gfmtopt.FromClauseInNewLine := cbfromclauseinnewline.Checked;
  gfmtopt.AlignAliasInSelectList := cbalignaliasinselectlist.Checked;

  {
  gFmtopt.AndOrUnderWhere := cbAndorunderWhere.Checked;
  gFmtopt.CompactMode := TCompactMode(rgCompactMode.Itemindex);
  gFmtopt.MaxLengthPerLine := strtointdef(edmaxlengthperline.Text,80);
  gFmtopt.LineWidth := strtointdef(edmaxlengthperline.Text,80);
  gFmtopt.RemoveLinebreakBeforeParse := cbRemoveLinebreakBeforeParse.Checked;
  gFmtopt.TrimQuotedCharOfEachLine := cbTrimQuotedCharOfEachLine.Checked;
  gFmtopt.QuotedCharOfEachLine := lzChar(edchar.text[1]);
  gFmtopt.UseTab := cbusetab.Checked;
  gfmtopt.TabSize := strtointdef(edtabsize.Text,2);
  gfmtopt.DictionaryFile := extractfilepath(application.ExeName)+'english.dic';
  gfmtopt.SortDeclareVars := cbsortdeclarevars.Checked;
  gfmtopt.AlignIFStatement := cbalignifstatement.Checked;
  gfmtopt.EmptyLines := TEmptyLinesOption(rgemptylines.ItemIndex);
  gfmtopt.IndentLen := strtointdef(edidentlen.Text,2);
  gfmtopt.LinebreakAfterDeclare :=cblinebreakafterdeclare.Checked;
  gfmtopt.InsertBlankLineInBatchSqls := rbinsertblankline.Checked;
  gfmtopt.MatheMaticalOption := TLinefeedsAndOrOption(rgmathop.ItemIndex);
  gfmtopt.MssqlIgnoreSemiColon := cbmssqlignoresemicolon.Checked;
  gfmtopt.EmptyLinesBetweenCmtAndSql := strtointdef(edEmptyLinesBetweenCmtAndSql.text,1);
  gfmtopt.LinebreakBeforeParamInExec := cbLinebreakBeforeParamInExec.Checked;
  }




  sqloutput.Clear;
  sqloutput.PlainText := isPlainText;
  sqloutput.MaxLength := 1024*1024;

  agsqlparser.SqlText.assign(sqlinput.Lines);

//  ret := agsqlparser.parse;
  statusbar1.Panels[0].Text := 'Formatting...';
  application.ProcessMessages;
  startCount(Counter);

  if isPlainText then
    begin
      with sqloutput.SelAttributes do
        begin
         Color := cldefault;
         name := 'Courier New';
         size := 10;
        end;

      ret := agsqlparser.prettyprint ;
      if ret = 0 then
        sqloutput.Lines.Add(agsqlparser.FormattedSqlText.text);

      //some sql with syntax error still can be formatted, so we check is there any syntax error here
      if agsqlparser.ErrorCount > 0 then
        sqloutput.lines.add('error token in input:'+agsqlparser.ErrorMessages);
    end
  else
    begin //rtf
        ret := agsqlparser.Parse;
        if ret <> 0 then
          begin
            sqloutput.lines.add('syntax error:'+agsqlparser.ErrorMessages);
          end
        else
          begin
            lccvt := tlzlangconverter.create(agsqlparser);
            try
             lcstrstream := tstringstream.Create(lccvt.ToRTF(ofrtf));
             sqloutput.Lines.LoadFromStream(lcstrstream);
            finally
              lcstrstream.free;
              lccvt.free;
            end;
          end;
    end;


  EscapedTime := StopCount(Counter);
  statusbar1.Panels[0].Text := Format('Escaped time : %f %s',[EscapedTime, 'sec']) ;


end;

procedure Tfrmdemo.btnpp_rtfClick(Sender: TObject);
begin
  pp(false);
end;

procedure Tfrmdemo.lbelementsClick(Sender: TObject);
var
  i,j : integer;
  lcattri : TLzHighlighterAttributes;

begin
  for i:=0 to lbelements.Count-1 do
    begin
      if lbelements.selected[i] then
        begin
          lcattri := lbelements.items.objects[i] as TLzHighlighterAttributes;

          cbstylebold.Checked := lcattri.StyleBold;
          cbstyleItalic.Checked := lcattri.StyleItalic;
          cbstyleUnderline.Checked := lcattri.StyleUnderline;
          cbstyleStrikeout.Checked := lcattri.StyleStrikeout;

          cbelement.ItemIndex := 0;
          for j:=1 to cbelement.Items.Count - 1 do
            begin
              if cbelement.Colors[j] = lcattri.Foreground then
                begin
                  cbelement.ItemIndex := j;
                  break;
                end;
            end;

          if cbelement.ItemIndex = 0 then
            cbelement.selected := lcattri.Foreground;


        end;
    end;
end;

procedure Tfrmdemo.cbelementChange(Sender: TObject);
var
  lcattri : TLzHighlighterAttributes;
begin
  if lbelements.SelCount = 0 then exit;
  lcattri := lbelements.items.objects[lbelements.itemindex] as TLzHighlighterAttributes;
  if assigned(lcattri) then
    begin
      lcattri.Foreground := cbelement.selected;
    end;
end;

procedure Tfrmdemo.cbstyleboldClick(Sender: TObject);
var
  lcattri : TLzHighlighterAttributes;
begin
  if lbelements.SelCount = 0 then exit;
  lcattri := lbelements.items.objects[lbelements.itemindex] as TLzHighlighterAttributes;
  if assigned(lcattri) then
    begin
      lcattri.StyleBold := (sender as tcheckbox).Checked;
    end;
end;

procedure Tfrmdemo.cbstyleitalicClick(Sender: TObject);
var
  lcattri : TLzHighlighterAttributes;
begin
  if lbelements.SelCount = 0 then exit;
  lcattri := lbelements.items.objects[lbelements.itemindex] as TLzHighlighterAttributes;
  if assigned(lcattri) then
    begin
      lcattri.StyleItalic := (sender as tcheckbox).Checked;
    end;

end;

procedure Tfrmdemo.cbstyleunderlineClick(Sender: TObject);
var
  lcattri : TLzHighlighterAttributes;
begin
  if lbelements.SelCount = 0 then exit;
  lcattri := lbelements.items.objects[lbelements.itemindex] as TLzHighlighterAttributes;
  if assigned(lcattri) then
    begin
      lcattri.Styleunderline := (sender as tcheckbox).Checked;
    end;


end;

procedure Tfrmdemo.cbstylestrikeoutClick(Sender: TObject);
var
  lcattri : TLzHighlighterAttributes;
begin
  if lbelements.SelCount = 0 then exit;
  lcattri := lbelements.items.objects[lbelements.itemindex] as TLzHighlighterAttributes;
  if assigned(lcattri) then
    begin
      lcattri.StyleStrikeout := (sender as tcheckbox).Checked;
    end;


end;

end.


